//****************************************************
//*
//*  Dummy UserAnalysis Script to be used with gui.C 
//*  Functions in this scripts are called by GUIMainMacro.C  
//*  
//*  In this script, global functions, UserInitialize() nad UserAnalysis()
//*  Must be defined.  UserInitialize() is called at job initialization 
//*  to initialize histograms, etc.  It is also called when reset historgam
//*  menu is selected from JSF Control Panel.  UserAnalysis() is called 
//*  during the event loop after executing Process functions of JSF modules
//*  and display event daia but before display histogram.  See GetEvent()
//*  function in GUIMainMacro.C, where UserAnalysis() is called.
//*
//*  UserSetOptions() and UserTerminate() may be defined in this file.
//*  UserSetOptions() are called before declaration of JSF modules.
//*  It can be used to set parameters optional for user analsis.
//*  UserTerminate() is called during the JSF termination process.
//*
//*  When runmode=4, UserModuleDefine() must be defined in this file.
//*  It is used to define JSF modules specific to user analysis.  
//*  
//*$Id: UserAnalysis.C,v 1.3 2005/04/08 02:18:47 fujiik Exp $
//*
//****************************************************

//_________________________________________________________
void UserAnotherModules()
{
//----------------------------------
//  Insert modules
//----------------------------------
   ZHAnalysis *zhanalysis    = new ZHAnalysis();
   zhanalysis->SetMakeBranch(kFALSE);
}


//_________________________________________________________
void UserInitialize()
{
//----------------------------------
// set parameters
//----------------------------------
#if 0
   //   S4TPCPadHit::SetSpatialResolution("experimental"); // default is "flat".

   // Set IP constraint ....
   // S4TPCTrack::SetIPConstraint(kTRUE);

   // Artificial bunch tagging
   Double_t t0 = 0.;
   S4TPCTrack::SetT0pedestal(t0); // [ns]
#endif
#if 0
   S4CALHitBuf::SetHitMakingScheme(1); // idealistic (smeared 1 hit/1 exact hit)
#endif
#if 0
   S4CALCluster::SetCalibFactorForEM(
               gJSF->Env()->GetValue("S4CALCluster.CalibrFactorForEM",36.44407));
   S4CALCluster::SetCalibFactorForHD(
               gJSF->Env()->GetValue("S4CALCluster.CalibrFactorForHD",34.38547));
#endif
}

//_________________________________________________________
void UserAnalysis()
{
#if 0
   S4PFOMakerBuf *pfombp = (S4PFOMakerBuf *)
                              gJSF->FindModule("S4PFOMaker")->EventBuf();
   pfombp->DebugPrint();
#endif
#if 0
   S4JetMakerBuf *jetmbp = (S4JetMakerBuf *)
                              gJSF->FindModule("S4JetMaker")->EventBuf();
   jetmbp->DebugPrint();
#endif
   //DrawJets(0,"p");  // default jets with PreHits
   DrawJets(2);        // forced 4 jets without PreHits

   S4GENMCTruth *genp = (S4GENMCTruth *)gJSF->FindModule("S4GENMCTruth");
   // genp->DebugPrint("Detailed");
   genp->DebugPrint();
}


static TCanvas     *cvp    = 0;
static TTUBE       *itubep = 0;
static TTUBE       *otubep = 0;
static TRotMatrix  *orotp = 0;
static TNode       *onodep = 0;
static TNode       *inodep = 0;
static Int_t        color  = 0;

//_________________________________________________________
void DrawJets(Int_t njets = 0, const Char_t *opt = "")
{
   TDirectory *last = gDirectory;
//----------------------------------
// initialize event display
//----------------------------------
#if 1
   if (!cvp) {
      cvp = new TCanvas("OED", "Event Display", 400, 10, 610, 610);
   } else {
      cvp->cd();
      cvp->Clear();
   }
   if (gROOT->GetVersionInt() < 51504) {
      TView   *vwp = new TView(1);
   } else {
      TView   *vwp = TView::CreateView(1,0,0);
   }
   vwp->SetRange(-360.,-360.,-360.,+360.,+360.,+360.);
   vwp->SetRange(-360.,-360.,-360.,+360.,+360.,+360.);
   Int_t ierr;
   vwp->SetView(10.,80.,80.,ierr);
#else
   cvp = (TCanvas *)gROOT->FindObject("EventDisplay");
   if (!cvp) return;
   else      cvp->cd();
#endif

   if (!otubep) otubep = new TTUBE("CALO","CALO","void",350.,350.,410.);
   if (!itubep) itubep = new TTUBE("CALI","CALI","void",210.,210.,270.);
   if (!orotp)  orotp  = new TRotMatrix("orot","orot",10.,80.,10.,80.,10.,80.);
   if (!onodep) {
      onodep = new TNode("ONODE","ONODE","CALO",0.,0.,0.,"orot");
      onodep->cd();
      inodep = new TNode("INODE","INODE","CALI");
   }
   onodep->Draw("pad same");

   TObjArray *jetsp = ((S4JetMakerBuf *)gJSF->FindModule("S4JetMaker")
                         ->EventBuf())->GetJetSetPtr(njets);

   if (jetsp && jetsp->GetEntries()) {
      TIter next(jetsp);
      S4Jet *jetp = 0;
      while ((jetp = (S4Jet *)next())) {
	 color++;
	 color %= 10;
	 jetp->Draw(color,opt);
      }
   }
   last->cd();
}

//_________________________________________________________
void DrawHist()
{
}
