      PROGRAM TSTIO
      implicit none
C
C      read in events and histogram contents
C
#include "stdlun.inc"
#include "stdcm1.inc"

      integer nread
      common/mycom/ nread, ifl, lok

      integer ifl,lok,istr,ntries,i
      character*20 filrd

C initialize HEP logical units
      lnhwrt=0
      lnhrd=23
      lnhdcy=0
      lnhout=22
      lnhout=6
      lnhpdf=0
      lnhdmp=0

      call tstbkem
      nread=0
C...initialize MCFio once only
      call mcfio_init()
C...now open and read events

          filrd='sample.stdhep'
          call stdxropen(filrd,ntries,istr,lok)
          if(lok.ne.0) write(lnhout,1001) filrd
          if(lok.ne.0) go to 200
          write(lnhout,1002) filrd
  10      call stdxrd(ifl,istr,lok)

          nread=nread+1
          if( ifl .ne. 4 ) then
             print *,' IFL .ne. 4 : nread=',nread,' ifl=',ifl
          endif
          if(lok.ne.0) go to 100

C... histogram cross section if it exists

          if(ifl.eq.100) write(lnhout,1003) filrd, generatorname
C... keep looping if this is not a STDHEP record
c          if(ifl.ne.4) go to 10
          if(nread.le.5) call dumpevents
          call tstflem
          go to 10
 100      continue
          call stdxend(istr)
 200      continue

C...print histograms
      call hrput(0,'sample.hbook','N')
1001  format(' could not open file ',a20)
1002  format(' file ',a20,' has been opened')
1003  format(/' file ',a20,' was generated by ',a20)
      end


C ---------------------------------------------------------------
      subroutine dumpevents
      implicit none
#include "stdhep.inc"
#include "hepev4.inc"
c      integer nread, ifl, lok
c      common /mycom/ nread, lfl, lok
      integer i,k


      print *,' '
      print *,' ================================================='
      print *,' One event dump'
      print *,' ================================================='

      print *,' nevhep=', nevhep
      print *,' nhep=',nhep
  
      do 100 i=1,nhep
        print *,' i=',i,' id=',idhep(i),'isthep=',isthep(i),
     >  ' jmohep=',jmohep(1,i),',',jmohep(2,i),
     >  ' jdahep=',jdahep(1,i),',',jdahep(2,i),
     >  ' phep=',(phep(k,i),k=1,5)
100   continue
      return 
      end

C ---------------------------------------------------------------
      SUBROUTINE TSTFLEM
      IMPLICIT NONE
C... fill histograms
#include "stdhep.inc"
#include "hepev4.inc"
      integer nread, lfl, lok
      common /mycom/ nread, lfl, lok

      INTEGER IOFF,I
      double precision esum, pxsum, pysum, pzsum

      esum=0
      pxsum=0
      pysum=0
      pzsum=0

      CALL HFILL(11,FLOAT(NEVHEP),0.,1.0)
      CALL HFILL(12,FLOAT(NHEP),0.,1.0)
      DO 100 I=1,NHEP
        CALL HFILL(13,FLOAT(IDHEP(I)),0.,1.0)
        CALL HFILL(14,FLOAT(ISTHEP(I)),0.,1.0)
        CALL HFILL(15,FLOAT(JMOHEP(1,I)),0.,1.0)
        CALL HFILL(16,FLOAT(JMOHEP(2,I)),0.,1.0)
        CALL HFILL(17,FLOAT(JDAHEP(1,I)),0.,1.0)
        CALL HFILL(18,FLOAT(JDAHEP(2,I)),0.,1.0)
        CALL HFILL(21,SNGL(PHEP(1,I)),0.,1.0)
        CALL HFILL(22,SNGL(PHEP(2,I)),0.,1.0)
        CALL HFILL(23,SNGL(PHEP(3,I)),0.,1.0)
        CALL HFILL(24,SNGL(PHEP(4,I)),0.,1.0)
        CALL HFILL(25,SNGL(PHEP(5,I)),0.,1.0)
        CALL HFILL(26,SNGL(VHEP(1,I)),0.,1.0)
        CALL HFILL(27,SNGL(VHEP(2,I)),0.,1.0)
        CALL HFILL(28,SNGL(VHEP(3,I)),0.,1.0)
        CALL HFILL(29,SNGL(VHEP(4,I)),0.,1.0)

        if( isthep(i).eq.1) then
           esum=esum+phep(4,i)
           pxsum=pxsum+phep(1,i)
           pysum=pysum+phep(2,i)
           pzsum=pzsum+phep(3,i)
        endif


 100  CONTINUE

      call hfill(111,sngl(eventweightlh),0.,1.0)
      call hfill(112,float(idruplh-10000),0.,1.0)

      call hfill(113,sngl(esum),0.,1.0)
      call hfill(114,sngl(esum),0.,1.0)
      call hfill(115,sngl(pxsum),0.,1.0)
      call hfill(116,sngl(pysum),0.,1.0)
      call hfill(117,sngl(pzsum),0.,1.0)
      call hfill(120,sngl(esum),0.,sngl(eventweightlh))
      call hfill(121,sngl(esum),0.,1.0)

      if( abs(esum-500.0).lt.0.005 ) then
         if( nread .lt.1000 ) then
            print *,' nread=',nread,
     >           ' nevhep=',nevhep,' nhep=',nhep,
     >           ' idruplh=',idruplh,' w=',eventweightlh,
     >           ' esum=',esum
         endif
      endif


      RETURN
      END

C ---------------------------------------------------------------
      SUBROUTINE TSTBKEM
C
      IMPLICIT NONE
C---   The HBOOK common
      REAL HMEMOR
      COMMON/PAWC/HMEMOR(50000)
      INTEGER IOFF
C---   Setup the HBOOK memory limit.
      CALL HLIMIT(50000)
C---   Book histograms.
      CALL HBOOK1(11,'StdHep: NEVHEP',100,0.0,100.0,0.)
      CALL HBOOK1(12,'StdHep: NHEP',100,0.,1000.,0.)
      CALL HBOOK1(13,'StdHep: IDHEP',100,0.,100.,0.)
      CALL HBOOK1(14,'StdHep: ISTHEP',100,0.,200.,0.)
      CALL HBOOK1(15,'StdHep: JMOHEP(1,)',100,0.,1000.,0.)
      CALL HBOOK1(16,'StdHep: JMOHEP(2,)',100,0.,1000.,0.)
      CALL HBOOK1(17,'StdHep: JDAHEP(1,)',100,0.,1000.,0.)
      CALL HBOOK1(18,'StdHep: JDAHEP(2,)',100,0.,1000.,0.)
      CALL HBOOK1(20,'StdHep: cross-section',100,0.,100.,0.)
      CALL HBOOK1(21,'StdHep: PHEP(1,)',100,-100.,100.,0.)
      CALL HBOOK1(22,'StdHep: PHEP(2,)',100,-100.,100.,0.)
      CALL HBOOK1(23,'StdHep: PHEP(3,)',100,-1000.,1000.,0.)
      CALL HBOOK1(24,'StdHep: PHEP(4,)',100,-1000.,1000.,0.)
      CALL HBOOK1(25,'StdHep: PHEP(5,)',50,-250.,250.,0.)
      CALL HBOOK1(26,'StdHep: VHEP(1,)',10,-1.,1.,0.)
      CALL HBOOK1(27,'StdHep: VHEP(2,)',10,-1.,1.,0.)
      CALL HBOOK1(28,'StdHep: VHEP(3,)',10,-1.,1.,0.)
      CALL HBOOK1(29,'StdHep: VHEP(4,)',10,0.,1.,0.)

      call hbook1(111,'StdHep: eventweight',100,-1.0,99.0,0.0)
      call hbook1(112,'StdHep: LPRUP',2000,0.,2000.0,0.0)

c      call hbook1(113,'StdHep: ESUM-fine',200,499.9,500.1,0.0)
      call hbook1(113,'StdHep: ESUM-fine',200,349.9,350.1,0.0)
      call hbook1(114,'StdHep: ESUM-corse',200,10.,360.0,0.0)
      call hbook1(115,'StdHep: PXSUM',200,-100.0,100.0,0.0)
      call hbook1(116,'StdHep: PYSUM',200,-100.0,100.0,0.0)
      call hbook1(117,'StdHep: PZSUM',200,-100.0,100.0,0.0)
      call hbook1(120,'StdHep: ESUM-with weight',300,341.0,347.0,0.0)
      call hbook1(121,'StdHep: ESUM-without weight',300,341.,347.0,0.0)

      RETURN
      END

