C***********************************************************************
C*
C* ------------------
C*  Subroutine PRDBIN(NRET)
C* ------------------
C*
C*(Function)
C*    Initialize data base routine, for production job.
C*
C*(Author)
C*    A. Miyamoto    Jun-16-1986  Original version.
C*    K. Fujii       Apr-14-1990  Filter ---> RDFLT.
C*
C***********************************************************************
C
      SUBROUTINE PRDBIN(NRET)
C
      EXTERNAL   PRCRED, PRCDYN, PRCSEQ
C
#include "prjctl.inc"
#include "prjflg.inc"
#include "prcvpt.inc"
#include "prcnsv.inc"
C
#include "prgenf.inc"
C
C -- Common size for data bse command interpreter.
C
      COMMON /DBCMDB/ NDBBUF(4,201)
      CHARACTER*16    DBCMDN(200)
      COMMON /DBCMDC/ DBCMDN
C
C------< Entry Point >--------------------------------------------------
C
C (1) Initialize command interpreter.
C
      NRET = 0
      CALL DBCINI(70,230)
C
C (2) Declare production and reduction job command.
C
      CALL DBCOPR('STEERING',     'LEVEL','I*4 ',NJBLVL( 2,1),IRET)
      CALL DBCOPR('USER',         'LEVEL','I*4 ',NJBLVL(20,1),IRET)
      CALL DBCOPR('STEERING',     'DEBUG','I*4 ',NJBDBG( 2,1),IRET)
      CALL DBCOPR('USER',         'DEBUG','I*4 ',NJBDBG(20,1),IRET)
      CALL DBCOPR('STEERING','CONSTANT','I*4 ',NCNVRS(IPxSTR-40), IRET)
C
      CALL DBCOPR('PRIDC',        'LEVEL','I*4 ',NJBLVL( 6,1),IRET)
      CALL DBCOPR('PRTPC',        'LEVEL','I*4 ',NJBLVL( 7,1),IRET)
      CALL DBCOPR('PRBTOF',       'LEVEL','I*4 ',NJBLVL( 8,1),IRET)
      CALL DBCOPR('PRBDC',        'LEVEL','I*4 ',NJBLVL( 9,1),IRET)
      CALL DBCOPR('PRBCL',        'LEVEL','I*4 ',NJBLVL(10,1),IRET)
      CALL DBCOPR('PRBMU',        'LEVEL','I*4 ',NJBLVL(11,1),IRET)
      CALL DBCOPR('PRETOF',       'LEVEL','I*4 ',NJBLVL(12,1),IRET)
      CALL DBCOPR('PREDC',        'LEVEL','I*4 ',NJBLVL(13,1),IRET)
      CALL DBCOPR('PRECL',        'LEVEL','I*4 ',NJBLVL(14,1),IRET)
      CALL DBCOPR('PRLUM',        'LEVEL','I*4 ',NJBLVL(15,1),IRET)
      CALL DBCOPR('PREMU',        'LEVEL','I*4 ',NJBLVL(16,1),IRET)
      CALL DBCOPR('PRLT',         'LEVEL','I*4 ',NJBLVL(17,1),IRET)
      CALL DBCOPR('PRVT',         'LEVEL','I*4 ',NJBLVL(18,1),IRET)
      CALL DBCOPR('PRCL',         'LEVEL','I*4 ',NJBLVL(19,1),IRET)
      CALL DBCOPR('PRVTX',        'LEVEL','I*4 ',NJBLVL(21,1),IRET)
      CALL DBCOPR('PRTCH',        'LEVEL','I*4 ',NJBLVL(22,1),IRET)
      CALL DBCOPR('PRFCL',        'LEVEL','I*4 ',NJBLVL(23,1),IRET)
      CALL DBCOPR('PRRCL',        'LEVEL','I*4 ',NJBLVL(24,1),IRET)
C
      CALL DBCOPR('PRIDC',        'DEBUG','I*4 ',NJBDBG( 6,1),IRET)
      CALL DBCOPR('PRTPC',        'DEBUG','I*4 ',NJBDBG( 7,1),IRET)
      CALL DBCOPR('PRBTOF',       'DEBUG','I*4 ',NJBDBG( 8,1),IRET)
      CALL DBCOPR('PRBDC',        'DEBUG','I*4 ',NJBDBG( 9,1),IRET)
      CALL DBCOPR('PRBCL',        'DEBUG','I*4 ',NJBDBG(10,1),IRET)
      CALL DBCOPR('PRBMU',        'DEBUG','I*4 ',NJBDBG(11,1),IRET)
      CALL DBCOPR('PRETOF',       'DEBUG','I*4 ',NJBDBG(12,1),IRET)
      CALL DBCOPR('PREDC',        'DEBUG','I*4 ',NJBDBG(13,1),IRET)
      CALL DBCOPR('PRECL',        'DEBUG','I*4 ',NJBDBG(14,1),IRET)
      CALL DBCOPR('PRLUM',        'DEBUG','I*4 ',NJBDBG(15,1),IRET)
      CALL DBCOPR('PREMU',        'DEBUG','I*4 ',NJBDBG(16,1),IRET)
      CALL DBCOPR('PRLT',         'DEBUG','I*4 ',NJBDBG(17,1),IRET)
      CALL DBCOPR('PRVT',         'DEBUG','I*4 ',NJBDBG(18,1),IRET)
      CALL DBCOPR('PRCL',         'DEBUG','I*4 ',NJBDBG(19,1),IRET)
      CALL DBCOPR('PRVTX',        'DEBUG','I*4 ',NJBDBG(21,1),IRET)
      CALL DBCOPR('PRTCH',        'DEBUG','I*4 ',NJBDBG(22,1),IRET)
      CALL DBCOPR('PRFCL',        'DEBUG','I*4 ',NJBDBG(23,1),IRET)
      CALL DBCOPR('PRRCL',        'DEBUG','I*4 ',NJBDBG(24,1),IRET)
C
      CALL DBCOPR('PRIDC', 'CONSTANT','I*4 ',NCNVRS(IPxIDC-40),IRET)
      CALL DBCOPR('PRTPC', 'CONSTANT','I*4 ',NCNVRS(IPxTPC-40),IRET)
      CALL DBCOPR('PRBTOF','CONSTANT','I*4 ',NCNVRS(IPxBTO-40),IRET)
      CALL DBCOPR('PRBDC', 'CONSTANT','I*4 ',NCNVRS(IPxBDC-40),IRET)
      CALL DBCOPR('PRBCL', 'CONSTANT','I*4 ',NCNVRS(IPxBCL-40),IRET)
      CALL DBCOPR('PRBMU', 'CONSTANT','I*4 ',NCNVRS(IPxBMU-40),IRET)
      CALL DBCOPR('PREDC', 'CONSTANT','I*4 ',NCNVRS(IPxEDC-40),IRET)
      CALL DBCOPR('PRECL', 'CONSTANT','I*4 ',NCNVRS(IPxECL-40),IRET)
      CALL DBCOPR('PRLUM', 'CONSTANT','I*4 ',NCNVRS(IPxLUM-40),IRET)
      CALL DBCOPR('PRVTX', 'CONSTANT','I*4 ',NCNVRS(25),IRET)
      CALL DBCOPR('PRTCH', 'CONSTANT','I*4 ',NCNVRS(26),IRET)
      CALL DBCOPR('PRFCL', 'CONSTANT','I*4 ',NCNVRS(27),IRET)
      CALL DBCOPR('PRRCL', 'CONSTANT','I*4 ',NCNVRS(28),IRET)
C
#ifdef UNIX
      CALL DBCOPR('PRIDC', 'FILE','S*128',CNFILES(IPxIDC-40),IRET)
      CALL DBCOPR('PRTPC', 'FILE','S*128',CNFILES(IPxTPC-40),IRET)
      CALL DBCOPR('PRBTOF','FILE','S*128',CNFILES(IPxBTO-40),IRET)
      CALL DBCOPR('PRBDC', 'FILE','S*128',CNFILES(IPxBDC-40),IRET)
      CALL DBCOPR('PRBCL', 'FILE','S*128',CNFILES(IPxBCL-40),IRET)
      CALL DBCOPR('PRBMU', 'FILE','S*128',CNFILES(IPxBMU-40),IRET)
      CALL DBCOPR('PREDC', 'FILE','S*128',CNFILES(IPxEDC-40),IRET)
      CALL DBCOPR('PRECL', 'FILE','S*128',CNFILES(IPxECL-40),IRET)
      CALL DBCOPR('PRLUM', 'FILE','S*128',CNFILES(IPxLUM-40),IRET)
      CALL DBCOPR('PRVTX', 'FILE','S*128',CNFILES(25),IRET)
      CALL DBCOPR('PRTCH', 'FILE','S*128',CNFILES(26),IRET)
      CALL DBCOPR('PRFCL', 'FILE','S*128',CNFILES(27),IRET)
      CALL DBCOPR('PRRCL', 'FILE','S*128',CNFILES(28),IRET)
#endif
C
      CALL DBCOPR('RDIDC',        'LEVEL','I*4 ',NJBLVL( 6,2),IRET)
      CALL DBCOPR('RDTPC',        'LEVEL','I*4 ',NJBLVL( 7,2),IRET)
      CALL DBCOPR('RDBTOF',       'LEVEL','I*4 ',NJBLVL( 8,2),IRET)
      CALL DBCOPR('RDBDC',        'LEVEL','I*4 ',NJBLVL( 9,2),IRET)
      CALL DBCOPR('RDBCL',        'LEVEL','I*4 ',NJBLVL(10,2),IRET)
      CALL DBCOPR('RDBMU',        'LEVEL','I*4 ',NJBLVL(11,2),IRET)
      CALL DBCOPR('RDETOF',       'LEVEL','I*4 ',NJBLVL(12,2),IRET)
      CALL DBCOPR('RDEDC',        'LEVEL','I*4 ',NJBLVL(13,2),IRET)
      CALL DBCOPR('RDECL',        'LEVEL','I*4 ',NJBLVL(14,2),IRET)
      CALL DBCOPR('RDLUM',        'LEVEL','I*4 ',NJBLVL(15,2),IRET)
      CALL DBCOPR('RDEMU',        'LEVEL','I*4 ',NJBLVL(16,2),IRET)
      CALL DBCOPR('RDFLT',        'LEVEL','I*4 ',NJBLVL(17,2),IRET)
      CALL DBCOPR('RDVTX',        'LEVEL','I*4 ',NJBLVL(21,2),IRET)
      CALL DBCOPR('RDTCH',        'LEVEL','I*4 ',NJBLVL(22,2),IRET)
      CALL DBCOPR('RDFCL',        'LEVEL','I*4 ',NJBLVL(23,2),IRET)
      CALL DBCOPR('RDRCL',        'LEVEL','I*4 ',NJBLVL(24,2),IRET)
C
      CALL DBCOPR('RDIDC',        'DEBUG','I*4 ',NJBDBG( 6,2),IRET)
      CALL DBCOPR('RDTPC',        'DEBUG','I*4 ',NJBDBG( 7,2),IRET)
      CALL DBCOPR('RDBTOF',       'DEBUG','I*4 ',NJBDBG( 8,2),IRET)
      CALL DBCOPR('RDBDC',        'DEBUG','I*4 ',NJBDBG( 9,2),IRET)
      CALL DBCOPR('RDBCL',        'DEBUG','I*4 ',NJBDBG(10,2),IRET)
      CALL DBCOPR('RDBMU',        'DEBUG','I*4 ',NJBDBG(11,2),IRET)
      CALL DBCOPR('RDETOF',       'DEBUG','I*4 ',NJBDBG(12,2),IRET)
      CALL DBCOPR('RDEDC',        'DEBUG','I*4 ',NJBDBG(13,2),IRET)
      CALL DBCOPR('RDECL',        'DEBUG','I*4 ',NJBDBG(14,2),IRET)
      CALL DBCOPR('RDLUM',        'DEBUG','I*4 ',NJBDBG(15,2),IRET)
      CALL DBCOPR('RDEMU',        'DEBUG','I*4 ',NJBDBG(16,2),IRET)
      CALL DBCOPR('RDVTX',        'DEBUG','I*4 ',NJBDBG(21,2),IRET)
      CALL DBCOPR('RDTCH',        'DEBUG','I*4 ',NJBDBG(22,2),IRET)
      CALL DBCOPR('RDFCL',        'DEBUG','I*4 ',NJBDBG(23,2),IRET)
      CALL DBCOPR('RDRCL',        'DEBUG','I*4 ',NJBDBG(24,2),IRET)
C
      CALL DBCOPR('RDFLT',        'DEBUG','I*4 ',NJBDBG(17,2),IRET)
C
      CALL DBCOPR('RDIDC', 'CONSTANT','I*4 ',NCNVRS(IRxIDC-40),IRET)
      CALL DBCOPR('RDTPC', 'CONSTANT','I*4 ',NCNVRS(IRxTPC-40),IRET)
      CALL DBCOPR('RDBTOF','CONSTANT','I*4 ',NCNVRS(IRxBTO-40),IRET)
      CALL DBCOPR('RDBDC', 'CONSTANT','I*4 ',NCNVRS(IRxBDC-40),IRET)
      CALL DBCOPR('RDBCL', 'CONSTANT','I*4 ',NCNVRS(IRxBCL-40),IRET)
      CALL DBCOPR('RDBMU', 'CONSTANT','I*4 ',NCNVRS(IRxBMU-40),IRET)
      CALL DBCOPR('RDEDC', 'CONSTANT','I*4 ',NCNVRS(IRxEDC-40),IRET)
      CALL DBCOPR('RDECL', 'CONSTANT','I*4 ',NCNVRS(IRxECL-40),IRET)
      CALL DBCOPR('RDLUM', 'CONSTANT','I*4 ',NCNVRS(IRxLUM-40),IRET)
      CALL DBCOPR('RDFLT','CONSTANT','I*4 ',NCNVRS(IRxFLT-40),IRET)
      CALL DBCOPR('RDVTX', 'CONSTANT','I*4 ',NCNVRS(21),IRET)
      CALL DBCOPR('RDTCH', 'CONSTANT','I*4 ',NCNVRS(22),IRET)
      CALL DBCOPR('RDFCL', 'CONSTANT','I*4 ',NCNVRS(23),IRET)
      CALL DBCOPR('RDRCL', 'CONSTANT','I*4 ',NCNVRS(24),IRET)
C
C  Constants for Simulator.
C
      CALL DBCOPR('SMSTR', 'CONSTANT','I*4 ',NCNVRS(29),IRET)
      CALL DBCOPR('SMTRG', 'CONSTANT','I*4 ',NCNVRS(30),IRET)
      CALL DBCOPR('SMIDC', 'CONSTANT','I*4 ',NCNVRS(31),IRET)
      CALL DBCOPR('SMTPC', 'CONSTANT','I*4 ',NCNVRS(32),IRET)
      CALL DBCOPR('SMBTOF','CONSTANT','I*4 ',NCNVRS(33),IRET)
      CALL DBCOPR('SMBDC', 'CONSTANT','I*4 ',NCNVRS(34),IRET)
      CALL DBCOPR('SMBCL', 'CONSTANT','I*4 ',NCNVRS(35),IRET)
      CALL DBCOPR('SMBMU', 'CONSTANT','I*4 ',NCNVRS(36),IRET)
      CALL DBCOPR('SMEDC', 'CONSTANT','I*4 ',NCNVRS(37),IRET)
      CALL DBCOPR('SMECL', 'CONSTANT','I*4 ',NCNVRS(38),IRET)
      CALL DBCOPR('SMLUM', 'CONSTANT','I*4 ',NCNVRS(39),IRET)
      CALL DBCOPR('SMVTX', 'CONSTANT','I*4 ',NCNVRS(40),IRET)
      CALL DBCOPR('SMTCH', 'CONSTANT','I*4 ',NCNVRS(41),IRET)
      CALL DBCOPR('SMFCL', 'CONSTANT','I*4 ',NCNVRS(42),IRET)
      CALL DBCOPR('SMRCL', 'CONSTANT','I*4 ',NCNVRS(43),IRET)
C
C
#ifdef UNIX 
      CALL DBCOPR('RDIDC', 'FILE','S*128 ',CNFILES(IRxIDC-40),IRET)
      CALL DBCOPR('RDTPC', 'FILE','S*128 ',CNFILES(IRxTPC-40),IRET)
      CALL DBCOPR('RDBTOF','FILE','S*128 ',CNFILES(IRxBTO-40),IRET)
      CALL DBCOPR('RDBDC', 'FILE','S*128 ',CNFILES(IRxBDC-40),IRET)
      CALL DBCOPR('RDBCL', 'FILE','S*128 ',CNFILES(IRxBCL-40),IRET)
      CALL DBCOPR('RDBMU', 'FILE','S*128 ',CNFILES(IRxBMU-40),IRET)
      CALL DBCOPR('RDEDC', 'FILE','S*128 ',CNFILES(IRxEDC-40),IRET)
      CALL DBCOPR('RDECL', 'FILE','S*128 ',CNFILES(IRxECL-40),IRET)
      CALL DBCOPR('RDLUM', 'FILE','S*128 ',CNFILES(IRxLUM-40),IRET)
      CALL DBCOPR('RDFLT','FILE','S*128 ',CNFILES(IRxFLT-40),IRET)
      CALL DBCOPR('RDVTX', 'FILE','S*128 ',CNFILES(21),IRET)
      CALL DBCOPR('RDTCH', 'FILE','S*128 ',CNFILES(22),IRET)
      CALL DBCOPR('RDFCL', 'FILE','S*128 ',CNFILES(23),IRET)
      CALL DBCOPR('RDRCL', 'FILE','S*128 ',CNFILES(24),IRET)
C
C  Constants for Simulator.
C
      CALL DBCOPR('SMSTR', 'FILE','S*128 ',CNFILES(29),IRET)
      CALL DBCOPR('SMTRG', 'FILE','S*128 ',CNFILES(30),IRET)
      CALL DBCOPR('SMIDC', 'FILE','S*128 ',CNFILES(31),IRET)
      CALL DBCOPR('SMTPC', 'FILE','S*128 ',CNFILES(32),IRET)
      CALL DBCOPR('SMBTOF','FILE','S*128 ',CNFILES(33),IRET)
      CALL DBCOPR('SMBDC', 'FILE','S*128 ',CNFILES(34),IRET)
      CALL DBCOPR('SMBCL', 'FILE','S*128 ',CNFILES(35),IRET)
      CALL DBCOPR('SMBMU', 'FILE','S*128 ',CNFILES(36),IRET)
      CALL DBCOPR('SMEDC', 'FILE','S*128 ',CNFILES(37),IRET)
      CALL DBCOPR('SMECL', 'FILE','S*128 ',CNFILES(38),IRET)
      CALL DBCOPR('SMLUM', 'FILE','S*128 ',CNFILES(39),IRET)
      CALL DBCOPR('SMVTX', 'FILE','S*128 ',CNFILES(40),IRET)
      CALL DBCOPR('SMTCH', 'FILE','S*128 ',CNFILES(41),IRET)
      CALL DBCOPR('SMFCL', 'FILE','S*128 ',CNFILES(42),IRET)
      CALL DBCOPR('SMRCL', 'FILE','S*128 ',CNFILES(43),IRET)
#endif
C
      CALL DBCOPR('EVENT', 'FIRST_EXP',   'I*4 ', NFSTEX, IRET)
      CALL DBCOPR('EVENT', 'LAST_EXP',    'I*4 ', NLSTEX, IRET)
      CALL DBCOPR('EVENT', 'FIRST_RUN',   'I*4 ', NFSTRN, IRET)
      CALL DBCOPR('EVENT', 'LAST_RUN',    'I*4 ', NLSTRN, IRET)
      CALL DBCOPR('EVENT', 'FIRST_EVENT', 'I*4 ', NFSTEV, IRET)
      CALL DBCOPR('EVENT', 'LAST_EVENT',  'I*4 ', NLSTEV, IRET)
      CALL DBCOPR('EVENT', 'DEBUG_FIRST', 'I*4 ', NFSTDB, IRET)
      CALL DBCOPR('EVENT', 'DEBUG_LAST',  'I*4 ', NLSTDB, IRET)
      CALL DBCOPR('EVENT', 'OUTPUT_FIRST','I*4 ', NFSTOT, IRET)
      CALL DBCOPR('EVENT', 'OUTPUT_LAST', 'I*4 ', NLSTOT, IRET)
C
      CALL DBCOPR('EVENT', 'GEN',         'I*4 ', NUMGEN, IRET)
 
C
      CALL DBCOPR('DATA',  'FIRST',       'I*4 ', NFSTEV, IRET)
      CALL DBCOPR('DATA',  'LAST',        'I*4 ', NLSTEV, IRET)
      CALL DBCOPR('DATA',  'DEBUG_FIRST', 'I*4 ', NFSTDB, IRET)
      CALL DBCOPR('DATA',  'DEBUG_LAST',  'I*4 ', NLSTDB, IRET)
      CALL DBCOPR('DATA',  'OUTPUT_FIRST','I*4 ', NFSTOT, IRET)
      CALL DBCOPR('DATA',  'OUTPUT_LAST', 'I*4 ', NLSTOT, IRET)
C
C     CALL DBCOPR('LIMIT',        'TIME_LEFT','R*4 ',RTIMLM,IRET)
C     CALL DBCOPR('LIMIT',        'RUN_TIME' ,'R*4 ',RCPUMX,IRET)
C
      CALL DBCSUB('PARAMETER', PRCRED,IRET)
      CALL DBCSUB('OUTPUT',    PRCRED,IRET)
      CALL DBCSUB('DELETE',    PRCRED,IRET)
      CALL DBCSUB('REMOVE',    PRCRED,IRET)
      CALL DBCSUB('SELECT',    PRCRED,IRET)
      CALL DBCSUB('INPUT',     PRCDYN,IRET)
      CALL DBCSUB('OUTFILE',   PRCDYN,IRET)

      CALL DBCSUB('ANAL',   PRCSEQ,IRET)


C
      RETURN
      END

