//*LastUpdate : v.01.01 undefined by undefined
//*-- Author  : undefined undefined

///////////////////////////////////////////////////////////////////
//
//  MyClsAnalysis
//
//  For Single Particle Event Analysis
//
//$Id: 
//  
//////////////////////////////////////////////////////////////////

#include <iostream>

#include "JSFSteer.h"
#include "MyClsAnalysis.h"
#include "S4PFObject.h"
#include "S4PFOMakerBuf.h"
#include "S4GENMCTruth.h"
#include "S4GENMCTruthBuf.h"
#include "S4PrimaryVertex.h"
#include "S4PrimaryParticle.h"


ClassImp(MyClsAnalysis)

//_____________________________________________________________________________
  MyClsAnalysis::MyClsAnalysis(const char *name, const char *title)
       : JSFModule(name,title)
{
}

//_____________________________________________________________________________
MyClsAnalysis::~MyClsAnalysis()
{
}

//_____________________________________________________________________________
Bool_t MyClsAnalysis::Initialize()
{
  // Initialize
  fNtuple=new TNtuple("fNtuple","PFO Events Ntuple","npfo:nch:neu:gcos:gp:e:px:py:pz:m");

  return kTRUE;
}

//_____________________________________________________________________________
Bool_t MyClsAnalysis::Process(Int_t nev)
{
// Generator Information

  S4GENMCTruth *s4gen=(S4GENMCTruth*)gJSF->FindModule("S4GENMCTruth");
  S4GENMCTruthBuf *s4genbuf=(S4GENMCTruthBuf*)s4gen->EventBuf();
  TObjArray *gens=s4genbuf->GetOutputBufPtr();
  S4PrimaryVertex *v=(S4PrimaryVertex*)gens->UncheckedAt(0);
  S4PrimaryParticle *p=v->GetParticleAt(0);
  /*
  std::cerr << "TrackID=" << p->GetTrackID() ;
  std::cerr << "PID=" << p->GetParticleID();
  std::cerr << "CosTh=" << (p->GetMomentum()).CosTheta() ;
  std::cerr << "p=" << (p->GetMomentum()).Mag();
  std::cerr << std::endl;
  */
  Float_t gcos=(p->GetMomentum()).CosTheta();
  Float_t gp=(p->GetMomentum()).Mag();

  S4PFOMaker *pfom=(S4PFOMaker*)gJSF->FindModule("S4PFOMaker");
  S4PFOMakerBuf *pfombuf=(S4PFOMakerBuf*)pfom->EventBuf();
  pfombuf->UpdatePFOs();
  Int_t npfo=pfombuf->GetEntries();
  TObjArray *pfos=pfombuf->GetOutputBufPtr();

   TIter nextpfo(pfos);
   S4PFObject *pfo;
   ANL4DVector psum(0.0,0.0,0.0,0.0);
   Int_t nch=0;
   Int_t nneu=0;
   
   
   while ((pfo = (S4PFObject *) (nextpfo()))) {
     psum += *pfo;
     Double_t charge=pfo->GetCharge();
     if ( TMath::Abs(charge) < 0.1 ) { nneu += 1; }
     else { nch += 1; }
   }
   /*
   std::cout << " psum...=" << psum.E() << " " << psum.Px() ;
   std::cout << psum.Py() << " " << psum.Pz() << std::endl;
   */
   fNtuple->Fill((Float_t)npfo,(Float_t)nch,(Float_t)nneu,
		 gcos,gp,
       (Float_t)psum.E(),(Float_t)psum.Px(),(Float_t)psum.Py(),
	(Float_t)psum.Pz(),(Float_t)psum.GetMass());

   return kTRUE;
}

