//////////////////////////////////////////////////////////////////
//
//  Geant4 execution in JSF framework
//
//
//$Id: JSFJupiter.cxx,v 1.11 2012/05/03 08:41:57 fujiik Exp $
//
//////////////////////////////////////////////////////////////////
#define __HISTORYKEEPER__

#include "JSFConfig.h"
#include <sstream>
#include <vector>

#include "TUnixSystem.h"

#include "JSFJ4RunManager.h"
#include "G4UImanager.hh"
#include "G4UIterminal.hh"
#include "G4UItcsh.hh"
#include "G4VisManager.hh"
#include "G4VVisManager.hh"
#include "G4MaterialTable.hh"
#include "G4Material.hh"
#include "G4Version.hh"

//#include "G4UIXm.hh"
#include "G4EmCalculator.hh"

#ifdef __APPLE__
#ifdef Status
#undef Status
#endif
#endif

#include "J4VersionInfo.hh"
#include "J4Timer.hh"
#include "J4DetectorConstruction.hh"
#include "QGSP.hh"
#include "LHEP.hh"
#if G4VERSION_NUMBER < 800
#include "QGSP_GN.hh"
#include "LHEP_GN.hh"
#endif
#if G4VERSION_NUMBER < 900
#include "QGSP_HP.hh"
#else
#include "QGSP_BIC_HP.hh"
#endif
#if G4VERSION_NUMBER < 800
#include "LHEP_HP.hh"
#endif
#if G4VERSION_NUMBER >= 900
#include "QGSP_BERT.hh"
#include "QGSP_BERT_HP.hh"
#include "QGSP_BERT_TRV.hh"
#if G4VERSION_NUMBER < 940
#include "LHEP_BERT_HP.hh"
#endif
#endif
#include "J4PhysicsList.hh"
#include "LCPhysicsList.hh"


#include "J4PrimaryGeneratorAction.hh"
#include "J4RunAction.hh"
#include "J4EventAction.hh"
#include "J4TrackingAction.hh"
#include "J4SteppingAction.hh"
#include "J4StackingAction.hh"
#include "TBookKeeper.hh"
#if 1
#include "J4HistoryKeeper.hh"
#endif


#include "J4IR.hh"
#include "J4BD.hh"
#include "J4VTX.hh"
#include "J4IT.hh"
#include "J4CAL.hh"
#include "J4CLX.hh"
#include "J4TPC.hh"
#include "J4CT.hh"
#include "J4CDC.hh"
#include "J4SOL.hh"
#include "J4MUD.hh"

TBookKeeper* TBookKeeper::fgBookKeeper = new TBookKeeper();

#include "JSFSteer.h"
#include "JSFJ4.h"
#include "JSFJupiter.h"

#include "JSFJ4TOutput.h"
#include "S4VTXExactHit.h"
#include "S4VTXMCTruthBuf.h"
#include "J4VTXPixelHit.hh"
#include "J4VTXLayerHit.hh"
#include "J4ITLayerHit.hh"
#include "S4ITExactHit.h"
#include "S4ITMCTruthBuf.h"
#include "J4CALHit.hh"
#include "J4CALPreHit.hh"
#include "S4CALMCTruthBuf.h"
#include "S4CALExactHit.h"
#include "S4CALPreHit.h"

#include "J4CLXHit.hh"
#include "J4CLXPreHit.hh"

#include "J4CALPostHit.hh"
#include "J4MUDHit.hh"
#include "J4MUDPreHit.hh"

#include "J4IRFCALHit.hh"
#include "S4FCALMCTruthBuf.h"
#include "S4FCALExactHit.h"
#include "J4IRFCALPreHit.hh"
#include "S4FCALPreHit.h"

#include "J4IRBCALHit.hh"
#include "S4BCALMCTruthBuf.h"
#include "S4BCALExactHit.h"
#include "J4IRBCALPreHit.hh"
#include "S4BCALPreHit.h"

#include "S4CALPostHit.h"
#include "S4MUDExactHit.h"
#include "S4MUDPreHit.h"
#include "S4MUDMCTruthBuf.h"

#include "JSFJ4PrimaryGeneratorAction.h"
#include "S4GENMCTruthBuf.h"
#include "S4HISTMCTruthBuf.h"
#include "S4HISTOutput.h"

#ifndef USE__J4CT
#include "J4CDCDriftRegionHit.hh"
#include "J4CDCStereoDriftRegionHit.hh"
#include "S4CDCMCTruthBuf.h"
#include "S4CDCExactHit.h"

#ifndef USE_CDC
#include "J4TPCLayerHit.hh"
#include "S4TPCMCTruthBuf.h"
#include "S4TPCExactHit.h"
#include "J4TPCPostHit.hh"
#include "S4TPCPostHit.h"
#endif

#else
#include "J4CTLayerHit.hh"
#include "S4CTExactHit.h"
#endif

#include "J4CommandArguments.hh"
#include "J4ParameterTable.hh"
#include "J4AParameter.hh"
#include "S4CALTowerGeom.h"

#include "J4OptDetHit.hh"
#include "S4OptDetExactHit.h"

#include "G4VModularPhysicsList.hh"
#include "J4PhysicsTuning.hh"

ClassImp(JSFJupiter)

#if __JSF_GNUC_VERSION__ >= 3
using namespace std;
#include <map>
typedef map<char*, J4Object*> JSFJ4Detectors_t;  // Used to swich on/off detectors
//typedef map<char*, J4Output*> JSFJ4Outputs_t;    // used to manage output
typedef JSFJ4TOutput<S4VExactHit, J4VHit> JSFJ4TOutput_t;
typedef map<char*, JSFJ4TOutput_t*> JSFJ4Outputs_t;    // used to manage output
#else
#include <hash_map>
typedef hash_map<char*, J4Object*> JSFJ4Detectors_t;  // Used to swich on/off detectors
typedef hash_map<char*, J4Output*> JSFJ4Outputs_t;    // used to manage output
#endif
#if __GNUC__ >= 5 || (__GNUC__ == 4 && __GNUC_MINOR__ >= 3)
#include <cstdlib>
#endif

JSFJ4Detectors_t gJSFJ4Detectors;
JSFJ4Outputs_t   gJSFJ4Outputs;
S4HISTOutput    *gBPOutputPtr = 0;

//_____________________________________________________________________________
JSFJupiter::JSFJupiter(const char *name, const char *title)
  : JSFJ4(name,title), fNcall(0), fNgood(0), fRunManager(0), fVisManager(0), fUImanager(0),
    fUseJupiterGenerator(kTRUE), fInitMacro(""), fpDetector(0)
{

  fCALTowerGeom=new S4CALTowerGeom();
  std::cerr << "fCALTowerGeom constructed..." << fCALTowerGeom << std::endl;
  if( !IsWritable() ) {
    TDirectory *lastdir=gDirectory;
    gJSF->GetInput()->cd("conf");
    this->Read("JSFJ4");
    lastdir->cd();
  }  
  if( IsWritable() ) { BuildJupiter() ; }

}

//_____________________________________________________________________________
JSFJupiter::~JSFJupiter()
{
  std::cerr << " fCALTowerGeom=" << fCALTowerGeom << " destructed" << std::endl;
  if ( fCALTowerGeom ) delete fCALTowerGeom;
}

//_____________________________________________________________________________
void JSFJupiter::BuildJupiter()
{
  Int_t ivlevel=gJSF->Env()->GetValue("JSFJ4.VerboseLevel",8);
  J4CommandArguments::SetVerboseLevel(ivlevel);
  std::cerr << " VerboseLevel=" << J4CommandArguments::VerboseLevel() << std::endl;

  string fnames(gJSF->Env()->GetValue("JSFJ4.ParameterTable","$JUPITERROOT/doc/gld_snowmass.dat"));
//  if( fnames != string("undef") ) {
     int ip0=0;
     int lennam=(int)fnames.size();
     for(int i=0;i<lennam;i++){
       if( fnames.substr(i,1) != string(":") ) continue;
       TString fread(fnames.substr(ip0,i-ip0).c_str());
       gSystem->ExpandPathName(fread);
       std::cerr << " Load file from " << fread.Data() << std::endl;
       J4ParameterTable::LoadFile(fread.Data());
       ip0=i+1;
     }
     if( lennam > ip0 ) {
       TString fread(fnames.substr(ip0, lennam-ip0).c_str());
       gSystem->ExpandPathName(fread);
       std::cerr << " Load file from " << fread.Data() << std::endl;
       J4ParameterTable::LoadFile(fread.Data());
     }

//  }

  // Construct the default run manager
  fRunManager = new JSFJ4RunManager();
  fUImanager  = G4UImanager::GetUIpointer();

  //*--------------------------------------------
  //* Install detector components...
  //*--------------------------------------------;

  fpDetector = new J4DetectorConstruction;
  JSFJ4Buf *buf=(JSFJ4Buf*)EventBuf();

  //* beam line

  if( gJSF->Env()->GetValue("JSFJ4.HasIR",1) == 1 ) {
    J4IR *pIR = new J4IR();
    pIR->SetMother(fpDetector->GetEXPHall());
    fpDetector->AddComponent(pIR);

    TObjArray *fcalhits=buf->AddComponent("FCALHits");
    TObjArray *fcalprehits=buf->AddComponent("FCALPreHits");
    gJSFJ4Detectors["IR"]=(J4Object*)pIR;
    gJSFJ4Outputs["IR"]=(JSFJ4TOutput_t*)(new JSFJ4TOutput<S4FCALExactHit,J4IRFCALHit>(fcalhits));
    gJSFJ4Outputs["IRpre"]=(JSFJ4TOutput_t*)(new JSFJ4TOutput<S4FCALPreHit,J4IRFCALPreHit>(fcalprehits));

    TObjArray *bcalhits=buf->AddComponent("BCALHits");
    TObjArray *bcalprehits=buf->AddComponent("BCALPreHits");
    gJSFJ4Detectors["IRBCAL"]=(J4Object*)pIR;
    gJSFJ4Outputs["IRBCAL"]=(JSFJ4TOutput_t*)(new JSFJ4TOutput<S4BCALExactHit,J4IRBCALHit>(bcalhits));
    gJSFJ4Outputs["IRBCALpre"]=(JSFJ4TOutput_t*)(new JSFJ4TOutput<S4BCALPreHit,J4IRBCALPreHit>(bcalprehits));
  }

  if( gJSF->Env()->GetValue("JSFJ4.HasBD",1) == 1 ) {
    J4BD *pBD = new J4BD();
    pBD->SetMother(fpDetector->GetEXPHall());
    fpDetector->AddComponent(pBD);
    gJSFJ4Detectors["BD"]=(J4Object*)pBD;
  }

  //* vtx
  if( gJSF->Env()->GetValue("JSFJ4.HasVTX",1) == 1 ) {
    J4VTX *pVTX = new J4VTX();
    pVTX->SetMother(fpDetector->GetEXPHall());
    fpDetector->AddComponent(pVTX);

    TObjArray *vtxhits=buf->AddComponent("VTXHits");
    gJSFJ4Detectors["VTX"]=(J4Object*)pVTX;
    //    gJSFJ4Outputs["VTX"]=new JSFJ4TOutput<JSFJ4VTXHit,J4VTXPixelHit>(vtxhits);
    gJSFJ4Outputs["VTX"]=(JSFJ4TOutput_t*)(new JSFJ4TOutput<S4VTXExactHit,J4VTXLayerHit>(vtxhits));
  }

  //* intermediate tracker

  if( gJSF->Env()->GetValue("JSFJ4.HasIT",1) == 1 ) {
    J4IT *pIT = new J4IT();
    pIT->SetMother(fpDetector->GetEXPHall());
    fpDetector->AddComponent(pIT);

    TObjArray *ithits=buf->AddComponent("ITHits");
    gJSFJ4Detectors["IT"]=(J4Object*)pIT;
    gJSFJ4Outputs["IT"]=(JSFJ4TOutput_t*)new JSFJ4TOutput<S4ITExactHit,J4ITLayerHit>(ithits);
  }

#ifndef USE__J4CT
  //* cdc
  if( gJSF->Env()->GetValue("JSFJ4.HasCDC",0) == 1 ) {
    J4CDC *pCDC = new J4CDC();
    pCDC->SetMother(fpDetector->GetEXPHall());
    fpDetector->AddComponent(pCDC);

    TObjArray *cdchits=buf->AddComponent("CDCHits");
    gJSFJ4Detectors["CDC"]=(J4Object*)pCDC;
    if (J4CDCParameterList::GetInstance()->IsAxialOnly()) {
       gJSFJ4Outputs["CDC"]=(JSFJ4TOutput_t*)new JSFJ4TOutput<S4CDCExactHit,J4CDCDriftRegionHit>(cdchits);
    } else {
       gJSFJ4Outputs["CDC"]=(JSFJ4TOutput_t*)new JSFJ4TOutput<S4CDCExactHit,J4CDCStereoDriftRegionHit>(cdchits);
    }
  }

#else

  // Use CT instead of CDC
  if( gJSF->Env()->GetValue("JSFJ4.HasCT",0) == 1 ) {
    J4CT *pCT = new J4CT();
    pCT->SetMother(fpDetector->GetEXPHall());
    fpDetector->AddComponent(pCT);

    TObjArray *cdchits=buf->AddComponent("CTHits");
    gJSFJ4Detectors["CT"]=(J4Object*)pCT;
    gJSFJ4Outputs["CT"]=(JSFJ4TOutput_t*)new JSFJ4TOutput<S4CTExactHit,J4CTLayerHit>(cdchits);
  }
#endif

  //* TPC
  if( gJSF->Env()->GetValue("JSFJ4.HasTPC",1) == 1 ) {
    J4TPC *pTPC = new J4TPC();
    pTPC->SetMother(fpDetector->GetEXPHall());
    fpDetector->AddComponent(pTPC);

    TObjArray *tpchits=buf->AddComponent("TPCHits");
    TObjArray *tpcposthits=buf->AddComponent("TPCPostHits");
    gJSFJ4Detectors["TPC"]=(J4Object*)pTPC;
    gJSFJ4Outputs["TPC"]=(JSFJ4TOutput_t*)new JSFJ4TOutput<S4TPCExactHit,J4TPCLayerHit>(tpchits);
    gJSFJ4Outputs["TPCPost"]=(JSFJ4TOutput_t*)new JSFJ4TOutput<S4TPCPostHit,J4TPCPostHit>(tpcposthits);
  }

  //* calorimeter
  if( gJSF->Env()->GetValue("JSFJ4.HasCAL",1) == 1 ) {
    J4CAL *pCAL = new J4CAL();
    pCAL->SetMother(fpDetector->GetEXPHall());
    fpDetector->AddComponent(pCAL);

    TObjArray *calhits=buf->AddComponent("CALHits");
    TObjArray *calprehits=buf->AddComponent("CALPreHits");
//    TObjArray *calposthits=buf->AddComponent("CALPostHits");
    gJSFJ4Detectors["CAL"]=(J4Object*)pCAL;
    gJSFJ4Outputs["CAL"]=(JSFJ4TOutput_t*)new JSFJ4TOutput<S4CALExactHit,J4CALHit>(calhits);
    gJSFJ4Outputs["CALpre"]=(JSFJ4TOutput_t*)new JSFJ4TOutput<S4CALPreHit,J4CALPreHit>(calprehits);
//    gJSFJ5Outputs["CALpost"]=new JSFJ4TOutput<S4CALPostHit,J4CALPostHit>(calposthits);
  }

  //* calorimeter for non-tower geometry
  else if( gJSF->Env()->GetValue("JSFJ4.HasCLX",0) == 1 ) {
    J4CLX *pCLX = new J4CLX();
    pCLX->SetMother(fpDetector->GetEXPHall());
    fpDetector->AddComponent(pCLX);

    TObjArray *calhits=buf->AddComponent("CALHits");
    TObjArray *calprehits=buf->AddComponent("CALPreHits");
//    TObjArray *calposthits=buf->AddComponent("CALPostHits");
    gJSFJ4Detectors["CAL"]=(J4Object*)pCLX;
    gJSFJ4Outputs["CAL"]=(JSFJ4TOutput_t*)new JSFJ4TOutput<S4CALExactHit,J4CLXHit>(calhits);
    gJSFJ4Outputs["CALpre"]=(JSFJ4TOutput_t*)new JSFJ4TOutput<S4CALPreHit,J4CLXPreHit>(calprehits);
  }


  //* Solenoid
  if( gJSF->Env()->GetValue("JSFJ4.HasSolenoid",1) == 1 ) {
    J4SOL *pSOL = new J4SOL();
    pSOL->SetMother(fpDetector->GetEXPHall());
    fpDetector->AddComponent(pSOL);
  }

  //* Muon detector
  if( gJSF->Env()->GetValue("JSFJ4.HasMUD",1) == 1 ) {
    J4MUD *pMUD = new J4MUD();
    pMUD->SetMother(fpDetector->GetEXPHall());
    fpDetector->AddComponent(pMUD);

    TObjArray *mudhits=buf->AddComponent("MUDHits");
    TObjArray *mudprehits=buf->AddComponent("MUDPreHits");
    gJSFJ4Detectors["MUD"]=(J4Object*)pMUD;
    gJSFJ4Outputs["MUD"]=(JSFJ4TOutput_t*)new JSFJ4TOutput<S4MUDExactHit,J4MUDHit>(mudhits);
    gJSFJ4Outputs["MUDpre"]=(JSFJ4TOutput_t*)new JSFJ4TOutput<S4MUDPreHit,J4MUDPreHit>(mudprehits);
  }

  //* Optional detectors
  if( gJSF->Env()->GetValue("JSFJ4.HasOptDet",0) == 1  ) {
    std::cerr << " OptDetHits will be created " << std::endl;
    TObjArray *opthits=buf->AddComponent("OptDetHits");
    gJSFJ4Outputs["OptDetHits"]=(JSFJ4TOutput_t*)new JSFJ4TOutput<S4OptDetExactHit,J4OptDetHit>(opthits);
  }

  //*--------------------------------------------
  //* Installation of detectors end
  //*--------------------------------------------

  fRunManager-> SetUserInitialization(fpDetector);

  // particles and physics processes
  string physlist(gJSF->Env()->GetValue("JSFJ4.PhysicsList","J4PhysicsList"));
  G4VModularPhysicsList* modPhysList = 0;
  if ( physlist == string("LCPhysicsList") ) {
      modPhysList = new LCPhysicsList();
      modPhysList->RegisterPhysics(new J4PhysicsTuning("tuning"));
      fRunManager->SetUserInitialization(modPhysList);
      G4cerr << "PhysicsList: LCPhysicsList is used" << G4endl;
  }
  else if( physlist == string("QGSP") ) {
      modPhysList = new QGSP();
      modPhysList->RegisterPhysics(new J4PhysicsTuning("tuning"));
      fRunManager->SetUserInitialization(modPhysList);
      G4cerr << "PhysicsList: QGSP is used" << G4endl;
  }
  else if( physlist == string("LHEP") ) {
      modPhysList = new LHEP();
      modPhysList->RegisterPhysics(new J4PhysicsTuning("tuning"));
      fRunManager->SetUserInitialization(modPhysList);
      G4cerr << "PhysicsList: LHEP is used" << G4endl;
  }
#if G4VERSION_NUMBER < 800
  else if( physlist == string("QGSP_GN") ) {
      modPhysList = new QGSP_GN();
      modPhysList->RegisterPhysics(new J4PhysicsTuning("tuning"));
      fRunManager->SetUserInitialization(modPhysList);
      G4cerr << "PhysicsList: QGSP_GN is used" << G4endl;
  }
  else if( physlist == string("LHEP_GN") ) {
      modPhysList = new LHEP_GN();
      modPhysList->RegisterPhysics(new J4PhysicsTuning("tuning"));
      fRunManager->SetUserInitialization(modPhysList);
      G4cerr << "PhysicsList: LHEP_GN is used" << G4endl;
  }
#endif
#if G4VERSION_NUMBER < 900
  else if( physlist == string("QGSP_HP") ) {
      modPhysList = new QGSP_HP();
      modPhysList->RegisterPhysics(new J4PhysicsTuning("tuning"));
      fRunManager->SetUserInitialization(modPhysList);
      G4cerr << "PhysicsList: QGSP_HP is used" << G4endl;
  }
#else
  else if( physlist == string("QGSP_BIC_HP") ) {
      modPhysList = new QGSP_BIC_HP();
      modPhysList->RegisterPhysics(new J4PhysicsTuning("tuning"));
      fRunManager->SetUserInitialization(modPhysList);
      G4cerr << "PhysicsList: QGSP_BIC_HP is used" << G4endl;
  }
#endif
#if G4VERSION_NUMBER < 800
  else if( physlist == string("LHEP_HP") ) {
      modPhysList = new LHEP_HP();
      modPhysList->RegisterPhysics(new J4PhysicsTuning("tuning"));
      fRunManager->SetUserInitialization(modPhysList);
      G4cerr << "PhysicsList: LHEP_HP is used" << G4endl;
  }
#endif
#if G4VERSION_NUMBER >= 900
  else if( physlist == string("QGSP_BERT_HP") ) {
      modPhysList = new QGSP_BERT_HP();
      modPhysList->RegisterPhysics(new J4PhysicsTuning("tuning"));
      fRunManager->SetUserInitialization(modPhysList);
      G4cerr << "PhysicsList: QGSP_BERT_HP is used" << G4endl;
  }
  else if( physlist == string("QGSP_BERT_TRV") ) {
      modPhysList = new QGSP_BERT_TRV();
      modPhysList->RegisterPhysics(new J4PhysicsTuning("tuning"));
      fRunManager->SetUserInitialization(modPhysList);
      G4cerr << "PhysicsList: QGSP_BERT_TRV is used" << G4endl;
  }
#if G4VERSION_NUMBER < 940
  else if( physlist == string("LHEP_BERT_HP") ) {
      modPhysList = new LHEP_BERT_HP();
      modPhysList->RegisterPhysics(new J4PhysicsTuning("tuning"));
      fRunManager->SetUserInitialization(modPhysList);
      G4cerr << "PhysicsList: LHEP_BERT_HP is used" << G4endl;
  }
#endif
  else if( physlist == string("QGSP_BERT") ) {
      modPhysList = new QGSP_BERT();
      modPhysList->RegisterPhysics(new J4PhysicsTuning("tuning"));
      fRunManager->SetUserInitialization(modPhysList);
      G4cerr << "PhysicsList: QGSP_BERT is used" << G4endl;
  }
#endif
  else if( physlist == string("J4PhysicsList")) {
    fRunManager->SetUserInitialization(new J4PhysicsList());
      G4cerr << "PhysicsList: J4PhysicsList is used" << G4endl;
  }
  else {
      G4cerr << "Fatal error : Physics List [" << physlist 
	<< "] is not defined " << G4endl ;
      exit(-1);
  }

 //---------------------------------------------
  // set mandatory user action class...

  //* primary generator
  JSFJ4PrimaryGeneratorAction *primaryGenerator=new JSFJ4PrimaryGeneratorAction();
  primaryGenerator->SetEventBuf(buf);
  buf->AddComponent("PrimaryVertices");
  
  fUseJupiterGenerator=gJSF->Env()->GetValue("JSFJ4.UseJupiterGenerator",1);
  primaryGenerator->SetUseJupiterGenerator(fUseJupiterGenerator);
  fRunManager->SetUserAction(primaryGenerator);

  //* user action classes... (optional)
  fRunManager-> SetUserAction(new J4RunAction(gJSF->Env()->GetValue("JSFJ4.JupiterOut","/dev/null")));
  fRunManager-> SetUserAction(new J4EventAction);
  fRunManager-> SetUserAction(new J4TrackingAction);
  fRunManager-> SetUserAction(new J4SteppingAction);
  fRunManager-> SetUserAction(new J4StackingAction);

#ifdef __HISTORYKEEPER__
  JSFEnv &env = *gJSF->Env();
  Bool_t keephistory = env.GetValue("JSFJ4.KeepHistory", 1) != 0;
  if (keephistory) {
    // Ask JSFJ4Buf by calling AddComponent(..) to create a new TObjArray
    // as a second element of a map file (with a key "BreakPoints") 
    // to store BreakPoints information.
    // Then JSFJ4Buf will write the contents of "BreakPoints" to a root file
    // at the end of each event.
    TObjArray *breakpoints = buf->AddComponent("BreakPoints");

    // Create an S4HISTOutput (that inherits from J4Output) by passing
    // a pointer to the output TObjArray to its constructor.
    // The constructor of S4HISTOutput will then set itself as an output
    // object to be called in J4BreakPoint::Output() which is in turn
    // called from J4EventAction::EndOfEventAction(..).
    // S4HistOutput::Output() will then add all of the BreakPoint
    // objects to the output TObjArray.
    gBPOutputPtr = new S4HISTOutput(breakpoints);
#if 1
    J4TrackingAction::GetInstance()->Add(J4HistoryKeeper::GetInstance());
#endif
  }
#endif

  fVisManager=0;
// #ifdef G4VIS_USE
  // initialize visualization package
//  fVisManager= new J4VisManager;
//  fVisManager-> Initialize();
//  G4cout << endl;
// #endif

  stringstream sin;
  sin << gJSF->Env()->GetValue("JSFJ4.MacroFile","run.mac");
  fInitMacro.ReadLine(sin);


}

//_____________________________________________________________________________
Bool_t JSFJupiter::Initialize()
{
  if( !IsWritable() ) { return kTRUE; }

  fNcall=0;
  fNgood=0;

  // Initialize G4 kernel
  fRunManager->Initialize();
  if( fVisManager ) fVisManager->Initialize();



  // Parameters defined in J4ParameterTable at the end of the job 
  // is copied to JSF's EnvParameter so that subsequent job can 
  // use it.
 
  std::vector<J4AParameter*> *ptbl=J4ParameterTable::GetTable();
  vector<J4AParameter*>::iterator ip;
  for(ip=ptbl->begin();ip!=ptbl->end();++ip) {
     J4AParameter *pp=*ip;
     gJSF->Env()->SetValue(pp->GetName().data(), pp->GetInput().data(), 
       kEnvChange);
  }

  const G4MaterialTable *mtbl=G4Material::GetMaterialTable();

  for(Int_t i=0;i<(G4int)G4Material::GetNumberOfMaterials();i++){
    const G4Material *aMaterial = (*mtbl)[i];
    string valname="J4.Material."+aMaterial->GetName() ;
    std::ostringstream valstr;
//   valstr << aMaterial->GetTotNbOfAtomsPerVolume() << " " ;
//   valstr << aMaterial->GetTotNbOfElectPerVolume() << " " ;
    double avA=Avogadro*aMaterial->GetDensity()/(g/mm3)/aMaterial->GetTotNbOfAtomsPerVolume();
    double avZ=aMaterial->GetTotNbOfElectPerVolume()/aMaterial->GetTotNbOfAtomsPerVolume();
    valstr << avA << " " ;
    valstr << avZ << " " ; // Average A and Z is written
    valstr << aMaterial->GetDensity()/(g/cm3) << " " ;
    valstr << aMaterial->GetRadlen()/cm << " " ;
    valstr << aMaterial->GetNuclearInterLength()/cm << " " ;

// Minimum energy loss ( energy loss is calculated for muon with beta-gamma=3.5 
// See "Review of Particle Physics, PDG group, 2004, Section 27.2 )
    G4ParticleTable *ptbl=G4ParticleTable::GetParticleTable();
    G4ParticleDefinition *muon=ptbl->FindParticle(13);  // muon 
    double muon_mass=muon->GetPDGMass();
    double muon_beta2=1.0/( 1 + 1.0/(3.5*3.5) );
    double muon_gamma=1.0/sqrt(1.0-muon_beta2);
    double muon_kinenergy=muon_mass*muon_gamma - muon_mass;
    G4EmCalculator dedxcal;
    double dedxmin=dedxcal.GetDEDX(muon_kinenergy, muon, aMaterial);
    valstr << dedxmin/(MeV/cm) << std::ends ;

    gJSF->Env()->SetValue(valname.data(), valstr.str().data(), kEnvChange);

  }

  string valname="J4.Material.Names";
  string values="";
  for(Int_t i=0;i<(G4int)G4Material::GetNumberOfMaterials();i++){
    const G4Material *aMaterial = (*mtbl)[i];
    if( i != 0 ) { values += ":" ; } 
    values += aMaterial->GetName(); 
  }
  gJSF->Env()->SetValue(valname.data(), values.data(),kEnvChange);


  //*--------------------------------------------
  //* SwitchOn/Off your detector...
  //*--------------------------------------------
  //* If you wants call SwitchOn/Off recursively,
  //* call virtual function with resolver, as
  //* "J4VDetectorComponent::SwitchOn()".
  //* SwitchOn/(Off() requires option flag
  //* "recursive" or other strings, however,
  //* default value is set as "recursive".

  JSFJ4Detectors_t::iterator  idet;
  idet=gJSFJ4Detectors.find("IR");
  if( idet != gJSFJ4Detectors.end() ) {
  	((J4IR*)((*idet).second))->J4VComponent::SwitchOn();
  }

  idet=gJSFJ4Detectors.find("VTX");
  if( idet != gJSFJ4Detectors.end() ) {
  	((J4VTX*)((*idet).second))->J4VDetectorComponent::SwitchOn();
  }

  idet=gJSFJ4Detectors.find("IT");
  if( idet != gJSFJ4Detectors.end() ) {
  	((J4IT*)((*idet).second))->J4VDetectorComponent::SwitchOn();
  }

#ifndef USE__J4CT
  idet=gJSFJ4Detectors.find("CDC");
  if( idet != gJSFJ4Detectors.end() ) {
    ((J4CDC*)((*idet).second))->J4VDetectorComponent::SwitchOn();
#if 0
    // Then, SwitchOff only SenseWires.
    for (G4int i=0; i<10; i++) {
      for (G4int j=0; j<5; j++) {
        stringstream str;
        str << "ExpName:CDC:SuperLayer" << (i+2)/3;
        if (i == 0) str << ":Layer";
        else        str << ":Layer" << (i-1)%3;
        str << ":Cell:DriftRegion"
            << j << ":SenseWire" << ends;
        J4VDetectorComponent::GetComponentPtrByName(str.str().data())->SwitchOff();
      }
    }
#endif
  }
#else
  idet=gJSFJ4Detectors.find("CT");
  if( idet != gJSFJ4Detectors.end() ) {
    ((J4CT*)((*idet).second))->J4VDetectorComponent::SwitchOn();
  }
#endif

  idet=gJSFJ4Detectors.find("TPC");
  if( idet != gJSFJ4Detectors.end() ) {
    ((J4TPC*)((*idet).second))->J4VDetectorComponent::SwitchOn();
  }

  idet=gJSFJ4Detectors.find("CAL");
  if( idet != gJSFJ4Detectors.end() ) {
    if( gJSF->Env()->GetValue("JSFJ4.HasCAL",1) == 1 ) {
       ((J4CAL*)((*idet).second))->J4VDetectorComponent::SwitchOn();
     }
    else if( gJSF->Env()->GetValue("JSFJ4.HasCLX",0) == 1 )  {
     	((J4CLX*)((*idet).second))->J4VDetectorComponent::SwitchOn();
     }
  }

  idet=gJSFJ4Detectors.find("MUD");
  if( idet != gJSFJ4Detectors.end() ) {
  	((J4MUD*)((*idet).second))->J4VDetectorComponent::SwitchOn();
  }

// Load CALTowerGeometry data into data member of S4CALTowerGeom object
  fCALTowerGeom->LoadJ4CALParameterList();
  TDirectory *lastdir=gDirectory;
  gJSF->GetOutput()->cd("conf");
  this->Write("JSFJ4");
  lastdir->cd();

  G4String command = "/control/execute ";
  G4String filename = fInitMacro.Data();

  fUImanager->ApplyCommand(command+filename);

  return kTRUE;
}

//_____________________________________________________________________________
Bool_t JSFJupiter::Terminate()
{
  const char *pfname=gJSF->Env()->GetValue("JSFJ4.Output.Parameter.FileName","undef");
  if ( string(pfname) != string("undef") ) {
      gJSF->Env()->WriteFile((char*)pfname);
  }

  J4Timer::PrintAllAccumulatedTimes();

  if( fVisManager )  delete fVisManager;
  if( fRunManager )  delete fRunManager;
  return kTRUE;
}

//_____________________________________________________________________________
Bool_t JSFJupiter::BeginRun(Int_t irun)
{

  if( !IsWritable() ) return kTRUE;

  fRunManager->RunInitialize();

  return kTRUE;
}

//_____________________________________________________________________________
Bool_t JSFJupiter::EndRun()
{

  if( !IsWritable() ) { return kTRUE; }

  fRunManager->RunTermination();

  return kTRUE;
}



//_____________________________________________________________________________
Bool_t JSFJupiter::Process(Int_t nev)
{
//
  JSFJ4Outputs_t::iterator id;
  for( id=gJSFJ4Outputs.begin() ; id!=gJSFJ4Outputs.end(); id++ ) {
    ((*id).second)->Delete();  // Issue JSFJ4TOutput::Delete()
  }
  if (gBPOutputPtr) gBPOutputPtr->Delete();

  JSFJ4Buf *buf=(JSFJ4Buf*)EventBuf();

  Bool_t runstat=fRunManager->SimulateOneEvent(nev);

  buf->SetEventID(fRunManager->GetCurrentEvent()->GetEventID());

  if ( runstat ) {
    return kTRUE;
  }
  else {
    gJSF->SetReturnCode(JSFSteer::kJSFDoEndRun) ;
    return kTRUE;
  }
}

