//////////////////////////////////////////////////////////////////
//
//  Geant4 execution in JSF framework
//
//
//$Id: JSFJ4BufManager.cxx,v 1.2 2008/03/25 15:15:51 fujiik Exp $
//
//////////////////////////////////////////////////////////////////
#define __HISTORYKEEPER__

#include "JSFConfig.h"
#include <sstream>
#include <vector>
#include <iostream>

#include "JSFSteer.h"
#include "JSFJ4.h"

#include "S4VTXExactHit.h"
#include "S4VTXMCTruthBuf.h"

#include "S4ITExactHit.h"
#include "S4ITMCTruthBuf.h"
#include "S4CALMCTruthBuf.h"
#include "S4CALExactHit.h"
#include "S4CALPreHit.h"

#include "S4FCALMCTruthBuf.h"
#include "S4FCALExactHit.h"
#include "S4FCALPreHit.h"

#include "S4BCALMCTruthBuf.h"
#include "S4BCALExactHit.h"
#include "S4BCALPreHit.h"

#include "S4CALPostHit.h"
#include "S4MUDExactHit.h"
#include "S4MUDPreHit.h"
#include "S4MUDMCTruthBuf.h"

#include "S4GENMCTruthBuf.h"
#include "S4HISTMCTruthBuf.h"
// include "S4HISTOutput.h"

#ifndef USE__J4CT
#include "S4CDCMCTruthBuf.h"
#include "S4CDCExactHit.h"
#ifndef USE_CDC
#include "S4TPCMCTruthBuf.h"
#include "S4TPCExactHit.h"
#include "S4TPCPostHit.h"
#endif
#else
#include "S4CTExactHit.h"
#endif


#include "JSFJ4BufManager.h"
#if __GNUC__ >= 5 || (__GNUC__ == 4 && __GNUC_MINOR__ >= 3)
#include <cstdlib>
#endif

ClassImp(JSFJ4BufManager)

using namespace std;

//_____________________________________________________________________________
JSFJ4BufManager::JSFJ4BufManager(const char *name, const char *title)
  : JSFModule(name,title)
{
}

//_____________________________________________________________________________
JSFJ4BufManager::~JSFJ4BufManager()
{
}

//_____________________________________________________________________________
Bool_t JSFJ4BufManager::Initialize()
{
  return kTRUE;
}

// --------------------------------------------------
Bool_t JSFJ4BufManager::Process(Int_t ev)
{
  JSFJ4Buf  *bufp = static_cast<JSFJ4Buf *>(gJSF->FindModule("JSFJ4")->EventBuf());

  TObjArray *vtxp  = bufp->GetComponent("VTXHits");
  TObjArray *itp   = bufp->GetComponent("ITHits");
  TObjArray *cdcp  = 0;
  if ( gJSF->Env()->GetValue("JSFJ4.HasCDC",0) == 1 ) {
    cdcp  = bufp->GetComponent("CDCHits");
  }
  TObjArray *tpcp  = bufp->GetComponent("TPCHits");
  TObjArray *tpcpp = bufp->GetComponent("TPCPostHits");

  if (vtxp) {
     S4VTXMCTruthBuf *vtxbufp = static_cast<S4VTXMCTruthBuf *>
                                (gJSF->FindModule("S4VTXMCTruth")->EventBuf());
     if (!vtxbufp) {
        cerr << " >>>>>> Error in JSFJ4BufManager::Process >>>>>>>>> " << endl
             << "    S4VTXCTruth not found! Abort. ev= "    << ev      << endl
             << " <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< " << endl;
        abort();
     } else {
        vtxbufp->SetInputBufPtr(vtxp);
     }
  }


  if (itp) {
     S4ITMCTruthBuf *itbufp = static_cast<S4ITMCTruthBuf *>
                                (gJSF->FindModule("S4ITMCTruth")->EventBuf());
     if (!itbufp) {
        cerr << " >>>>>> Error in JSFJ4BufManager::Process >>>>>>>>> " << endl
             << "     S4ITCTruth not found! Abort. ev= "    << ev      << endl
             << " <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< " << endl;
        abort();
     } else {
        itbufp->SetInputBufPtr(itp);
     }
  }

  if (tpcp) {
     S4TPCMCTruthBuf *tpcbufp = static_cast<S4TPCMCTruthBuf *>(gJSF->FindModule("S4TPCMCTruth")->EventBuf());
     if (!tpcbufp) {
        cerr << " >>>>>> Error in JSFJ4BufManager::Process >>>>>>>>> " << endl
             << "     S4TPCMCTruth not found! Abort. ev= "  << ev      << endl
             << " <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< " << endl;
        abort();
     } else {
        tpcbufp->SetInputBufPtr(tpcp);
        tpcbufp->SetPostHitsPtr(tpcpp);
     }
  } else if (cdcp) {
     S4CDCMCTruthBuf *cdcbufp = static_cast<S4CDCMCTruthBuf *>(gJSF->FindModule("S4CDCMCTruth")->EventBuf());
     if (!cdcbufp) {
        cerr << " >>>>>> Error in JSFJ4BufManager::Process >>>>>>>>> " << endl
             << "     S4CDCMCTruth not found! Abort. ev= "  << ev      << endl
             << " <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< " << endl;
        abort();
     } else {
        cdcbufp->SetInputBufPtr(cdcp);
     }
  }

  TObjArray *calp  = bufp->GetComponent("CALHits");
  TObjArray *calpp = bufp->GetComponent("CALPreHits");

  //* calorimeter
  //  if( gJSF->Env()->GetValue("JSFJ4.HasCAL",1) != 1 &&
  //      gJSF->Env()->GetValue("JSFJ4.HasCLX",0) == 1 )  {
  //      calp  = bufp->GetComponent("CLXHits");
  //      calpp = bufp->GetComponent("CLXPreHits");
  //   }

//  TObjArray *calpost = bufp->GetComponent("CALPostHits");
  if (calp) {
     S4CALMCTruth *calmtp = static_cast<S4CALMCTruth *>(gJSF->FindModule("S4CALMCTruth","quiet"));
     S4CALMCTruthBuf *calbufp = calmtp 
                    ? static_cast<S4CALMCTruthBuf *>(calmtp->EventBuf()) : 0;
     if (!calbufp) {
#if 0
        cerr << " >>>>>> Error in JSFJ4BufManager::Process >>>>>>>>> " << endl
             << "     S4CALMCTruth not found! Abort. ev= "  << ev      << endl
             << " <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< " << endl;
        abort();
#else
        cerr << " >>>>>> Warning in JSFJ4BufManager::Process >>>>>>> " << endl
             << "     S4CALMCTruth not found!  ev= " << ev             << endl
             << " <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< " << endl;
#endif
     } else {
        calbufp->SetInputBufPtr(calp);
        calbufp->SetPreHitsPtr(calpp);
//	calbufp->SetPreHitsPtr(calpost);
     }
  }

  TObjArray *fcalp  = bufp->GetComponent("FCALHits");
  TObjArray *fcalpp = bufp->GetComponent("FCALPreHits");
  if (fcalp) {
     S4FCALMCTruth *fcalmtp = static_cast<S4FCALMCTruth *>(gJSF->FindModule("S4FCALMCTruth","quiet"));
     S4FCALMCTruthBuf *fcalbufp = fcalmtp 
                    ? static_cast<S4FCALMCTruthBuf *>(fcalmtp->EventBuf()) : 0;
     if (fcalbufp) {
        fcalbufp->SetInputBufPtr(fcalp);
        fcalbufp->SetPreHitsPtr(fcalpp);
     }
  }
  TObjArray *bcalp  = bufp->GetComponent("BCALHits");
  TObjArray *bcalpp  = bufp->GetComponent("BCALPreHits");
  if (bcalp) {
     S4BCALMCTruth *bcalmtp = static_cast<S4BCALMCTruth *>(gJSF->FindModule("S4BCALMCTruth","quiet"));
     S4BCALMCTruthBuf *bcalbufp = bcalmtp 
                    ? static_cast<S4BCALMCTruthBuf *>(bcalmtp->EventBuf()) : 0;
     if (bcalbufp) {
        bcalbufp->SetInputBufPtr(bcalp);
        bcalbufp->SetPreHitsPtr(bcalpp);
     }
  }

  // For MUD
  TObjArray *mudp  = bufp->GetComponent("MUDHits");
  TObjArray *mudpp = bufp->GetComponent("MUDPreHits");
  if (mudp) {
     S4MUDMCTruthBuf *mudbufp = static_cast<S4MUDMCTruthBuf *>
                                (gJSF->FindModule("S4MUDMCTruth")->EventBuf());
     if (!mudbufp) {
        cerr << " >>>>>> Error in JSFJ4BufManager::Process >>>>>>>>> " << endl
             << "    S4MUDMCTruth not found! Abort. ev= "    << ev      << endl
             << " <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< " << endl;
        //abort();
     } else {
        mudbufp->SetInputBufPtr(mudp);
        mudbufp->SetPreHitsPtr(mudpp);
     }
  }

  TObjArray *genp   = bufp->GetComponent("PrimaryVertices");
  if (genp) {
     S4GENMCTruthBuf *genbufp = static_cast<S4GENMCTruthBuf *>(gJSF->FindModule("S4GENMCTruth")->EventBuf());
     if (!genbufp) {
        cerr << " >>>>>> Error in JSFJ4BufManager::Process >>>>>>>>> " << endl
             << "     S4GENMCTruth not found! Abort. ev= "  << ev      << endl
             << " <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< " << endl;
        abort();
     } else {
        genbufp->SetInputBufPtr(genp);
     }
  }

  // Ask JSFJ4Buf to return pointer to the TObjArray named "BreakPoints".
  TObjArray *histp   = bufp->GetComponent("BreakPoints");
  if (histp) {
     S4HISTMCTruthBuf *histbufp = static_cast<S4HISTMCTruthBuf *>(gJSF->FindModule("S4HISTMCTruth")->EventBuf());
     if (!histbufp) {
        cerr << " >>>>>> Error in JSFJ4BufManager::Process >>>>>>>>> " << endl
             << "     S4HISTMCTruth not found! Abort. ev= "  << ev     << endl
             << " <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< " << endl;
        abort();
     } else {
        // Tell S4HISTMCTruthBuf the location of the TObjArray containing
        // the BreakPoints information.
        histbufp->SetInputBufPtr(histp);
     }
  }

  return kTRUE;
}
