#ifndef __S4BCALExactHit__
#define __S4BCALExactHit__

///////////////////////////////////////////////////////////////////////
//
//  JSFJ4 BCAL Hit data
//
//$Id: S4BCALExactHit.h,v 1.3 2006/06/07 01:22:02 miyamoto Exp $
//
///////////////////////////////////////////////////////////////////////

#include "S4VExactHit.h"
#include <TVector3.h>

class J4IRBCALHit;
//class J4CLXHit;
//class S4BCALPreHit;

// *******************************************************
class S4BCALExactHit : public S4VExactHit
{
 public:
  S4BCALExactHit();
  /*
  S4BCALExactHit(Int_t     hitID,       // hit ID
                Int_t     pcode,       // PDG code
          const TVector3  &pos,         // position [cm]
                Double_t  tof,         // TOF      [nsec]
                Double_t  edep,        // energy deposit [GeV]
                Int_t     preHitID,    // pre hit ID
                Int_t     cellID,      // cell ID
                Int_t     isBarrel,    // energy deposit [GeV]
                Int_t     isEM,        // energy deposit [GeV]
          const TVector3 &xcell,       // cell position [cm]
          const TVector3 &xcm,         // E-weighted pos [cm*GeV]
		Int_t     trackID,     // track ID
		Int_t     mtrackID);   // mother track ID
  */
  S4BCALExactHit(J4IRBCALHit *ahit);
  virtual ~S4BCALExactHit();

  // virtual functions in S4VExactHit
  static void SetSortBy(Char_t *opt="");
  virtual Int_t Compare(const TObject*) const;
  virtual Bool_t IsSortable();

  inline Int_t        GetPreHitID(){ return fPreHitID; }
  inline Int_t        GetCellID(){ return fCellID; }
  //  inline Bool_t       IsBarrel(){ return fIsBarrel;  }
  //  inline Bool_t       IsEM(){ return fIsEM; }
  //  inline TVector3     GetCellPosition(){ return fCellPosition; }
  //  inline TVector3     GetCellXcm(){ return fCellXcm; }
  inline TVector3     Get1stHit(){ return f1stHit; }
  //  inline S4BCALPreHit* GetPreHitPtr(){ return fPreHitPtr; }
  //  inline void         SetPreHitPtr(S4BCALPreHit *p){fPreHitPtr = p; }
 
  virtual void Print(const Option_t *opt = "") const; //overrides TObject's

 private:
  Int_t        fPreHitID;         // PreHitID
  Int_t        fCellID;           // CellID
  //  Bool_t       fIsBarrel;         // IsBarrel
  //  Bool_t       fIsEM;             // IsEM
  //  TVector3     fCellPosition;     // Cell position in cm
  //  TVector3     fCellXcm;          // Edep-weighted position
  TVector3     f1stHit;          // Edep-weighted position
  //  S4BCALPreHit *fPreHitPtr;        // pointer to pre hit 
  
  ClassDef(S4BCALExactHit, 2)  // S4BCALExactHit class

};

#endif
