#ifndef __S4BCALMCTRUTH__
#define __S4BCALMCTRUTH__
//*************************************************************************
//* ----------------
//* S4BCALMCTruth Class
//* ----------------
//* (Description)
//* (Requires)
//*	S4VMCTruth:
//* (Provides)
//*	S4BCALMCTruth		: steering class
//* (Update Record)
//*	2006/02/01 A.Miyamot Original version.
//*************************************************************************

#include <fstream>
#include "S4VMCTruth.h"

using namespace std;

class S4BCALMCTruth : public S4VMCTruth {

public:
   S4BCALMCTruth(const Char_t *fname = "hit.dat", 
                const Char_t *name  = "S4BCALMCTruth",
                const Char_t *title = "Get BCAL ExactHit data");
	        
   virtual ~S4BCALMCTruth();

   Bool_t BeginRun(Int_t nrun);
   Bool_t Process (Int_t ev);

   void   DebugPrint(const Char_t *opt = "");
   
private:
   Char_t    *fInputFileName;            //!
   ifstream  *fInputStream;              //!

   ClassDef(S4BCALMCTruth, 1) // Read CAL ExactHit Data
};

#endif

