#ifndef __S4CALMCTRUTHBUF__
#define __S4CALMCTRUTHBUF__
//*************************************************************************
//* ----------------
//* S4VMCTruthBuf Class
//* ----------------
//* (Description)
//*	This set of classes reads ascii output of JUPITER and
//*	put them into root objects.
//* (Requires)
//*	S4VMCTruthBuf:
//* (Provides)
//*	S4VMCTruthBuf		: steering class
//* (Update Record)
//*	2004/11/24  S.Yamamoto	Original version.
//*************************************************************************

#include "S4VMCTruthBuf.h"
#include "S4CALMCTruth.h"

// ---------------
// MonteCarlo Truth Buffer
// ---------------

class S4CALMCTruthBuf : public S4VMCTruthBuf {

public:
  S4CALMCTruthBuf(const Char_t *name  = "S4CALMCTruthBuf",
                  const Char_t *title = "CAL MCTruth Buf", 
                  S4CALMCTruth *mod =0,
		  Int_t         bufsize = 20000);

  S4CALMCTruthBuf(S4CALMCTruth *mod,
                  const Char_t *name = "S4CALMCTruthBuf",
		  const Char_t *title = "CAL MCTruth Buf",
                  Int_t         bufsize = 20000);

  virtual   ~S4CALMCTruthBuf();


  TObjArray *GetInputBufPtr()                { return fInputBufPtr; }
  TObjArray *GetPreHitsPtr()                 { return fPreHitsPtr;  } 
  void       SetInputBufPtr(TObjArray *bufp) { fInputBufPtr = bufp; }
  void       SetPreHitsPtr(TObjArray *prep)  { fPreHitsPtr  = prep; }

  Bool_t     ReadFile();

  void       UpdatePtrs();

private:
  TObjArray *fInputBufPtr;             //! 
  TObjArray *fPreHitsPtr;              //!
  
  ClassDef(S4CALMCTruthBuf, 1) // CAL raw data buffer
};

#endif

