#ifndef __S4OptDetEXACTHIT__
#define __S4OptDetEXACTHIT__
//*************************************************************************
//* --------------------
//* S4OptDetExactHit
//* --------------------
//* (Description)
//*	OptDetector Hit class.
//*	Mother class : TObject
//*     
//* (Update Record)
//*	2006/06/05  A.Miyamoto 	Original version.
//*************************************************************************

#include "TObject.h"
#include "TVector3.h"

#include "S4VExactHit.h"

class J4OptDetHit;

class S4OptDetExactHit : public S4VExactHit {

public:
    
  S4OptDetExactHit();
  S4OptDetExactHit(const J4OptDetHit *hitp);
  /*
  S4OptDetExactHit(      Int_t     evtID,
                     Int_t     layerID,
                     Int_t     trackID,
                     Int_t     mothertrackID,
                     Int_t     hitID,
                     Int_t     pcode,
                     Int_t     charge,
               const TVector3 &pre,
               const TVector3 &post,
               const TVector3 &momentum,
                     Double_t  totE,
                     Double_t  edep,
                     Double_t  tof);
  */

  virtual ~S4OptDetExactHit();
  
  virtual void DebugPrint(const Char_t *opt = "");
  
  //static void  SetSortBy(Char_t *opt = "TrackID");
  //Bool_t       IsSortable() const;
  //Int_t        Compare(const TObject *obj) const;  
  
  
  //Get method -----------//
  
  inline Int_t GetDetID(){ return fDetID;}
  inline Int_t GetDetSerialID(){ return fDetSerialID;}
  inline TVector3 GetPostPosition(){ return fPostPosition;}

  //Set method -----------//
  void SetDetID(Int_t id){ fDetID=id; }
  void SetDetSerialID(Int_t id){ fDetSerialID=id; }
  void SetPostPosition(TVector3 x){ fPostPosition=x; }

private:
  Int_t  fDetID;
  Int_t  fDetSerialID;
  TVector3 fPostPosition;

  static Int_t	fOptDetExactHitSortBy; //!
  
  	
  ClassDef(S4OptDetExactHit, 1) // Datum 
};


#endif
