//*************************************************************************
//* --------------------
//* S4CALClusterMaker
//* --------------------
//* (Description)
//*	This set of classes makes CALClusters.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2004/09/02  S.Yamamoto	Original version.
//*************************************************************************

#include <iostream>
#include "JSFSteer.h"
#include "S4CALHitMaker.h"
#include "S4CALSmallClusterMaker.h"
#include "S4CALSmallClusterMakerBuf.h"

#include <ctime>

//#define __LDC__

ClassImp(S4CALSmallClusterMaker)

//=====================================================================
//* constructor -------------------------------------------------------

S4CALSmallClusterMaker::S4CALSmallClusterMaker(const Char_t *name, const Char_t *title)
       		  : JSFModule(name,title)
{
}

//=====================================================================
//* destructor --------------------------------------------------------

S4CALSmallClusterMaker::~S4CALSmallClusterMaker()
{
}

//=====================================================================
//* Initialize --------------------------------------------------------

Bool_t S4CALSmallClusterMaker::Initialize()
{
   std::cerr << " S4CALSmallClusterMaker::Initialize called " << std::endl;
   fEventBuf = new S4CALSmallClusterMakerBuf(this);

   return kTRUE;
}

//=====================================================================
//* BeginRun ----------------------------------------------------------

Bool_t S4CALSmallClusterMaker::BeginRun(Int_t /* run */ )
{
   return kTRUE;
}

//=====================================================================
//* Process -----------------------------------------------------------

Bool_t S4CALSmallClusterMaker::Process(Int_t /* ev */ )
{

   clock_t start = clock();
   std::cout << " S4CALSmallCluster::Process() is called..." << std::endl;

   S4CALHitMaker *hmp = (S4CALHitMaker *)gJSF->FindModule("S4CALHitMaker");
   S4CALHitBuf *hmbufp = (S4CALHitBuf *)hmp->EventBuf();
   S4CALSmallClusterMakerBuf *cmbufp;
   cmbufp = (S4CALSmallClusterMakerBuf *)EventBuf();
   cmbufp->SetInputDataBufPtr(hmbufp);

#ifdef __LDC__
   cmbufp->MakeSmallClustersLDC();
#else
   cmbufp->MakeSmallClusters();
#endif

   clock_t end = clock();
   std::cout << " evt = " << gJSF->GetEventNumber() << std::endl;
   std::cout << " S4CALSmallCluster::Process() is finished..." << std::endl;
   std::cout << " spended time: " << (Float_t)(end-start)/CLOCKS_PER_SEC
	     << " (sec)" << std::endl;

   return kTRUE;
}

