//*************************************************************************
//* ---------------------
//* S4ITTrackHit Class
//* ---------------------
//* (Description)
//*	Class for a single hit.
//* (Requires)
//*	TObject
//* (Provides)
//*	S4ITTrackHit		: 
//* (Update Record)
//*	2004/08/26  A.Yamaguchi
//*************************************************************************

#include "S4ITTrackHit.h"

ClassImp(S4ITTrackHit)


//=====================================================================
//* constructor -------------------------------------------------------

S4ITTrackHit::S4ITTrackHit()
{
}

S4ITTrackHit::S4ITTrackHit(S4ITHit *ht)
             : U4ITTrackHit(ht)
{
}

S4ITTrackHit::S4ITTrackHit(const S4ITTrackHit &ht)
             : U4ITTrackHit(ht)
{
}

//=====================================================================
//* destructor --------------------------------------------------------

S4ITTrackHit::~S4ITTrackHit()
{
}

//=====================================================================
//* destructor --------------------------------------------------------

void S4ITTrackHit::SetSortBy(Char_t *opt )
{
   switch (opt[2]) {
      case 'm':       // sort by "Time"
      default:
         U4VTrackHit::SetSortBy(0);
         break;
   }
}

Int_t S4ITTrackHit::Compare(const TObject *obj) const
{
   switch (GetSortBy()) {
      case 0: 
      default: {
         Double_t tof  = const_cast<S4ITTrackHit *>(this)
                              ->GetHitPtr()->GetExactHitPtr()->GetTOF();
         Double_t tofo = ((S4ITTrackHit *)obj)
                              ->GetHitPtr()->GetExactHitPtr()->GetTOF();
         return (tof < tofo ? -1 : (tof > tofo ? 1 : 0));
         break;
      }
   }
}

