//*************************************************************************
//* --------------------
//* S4JetMaker
//* --------------------
//* (Description)
//*	This set of classes makes Jets.
//* (Requires)
//*     JSFModules:
//* (Provides)
//*     S4JetMaker              : steering class          
//* (Update Record)
//*	2004/10/05  S.Yamamoto	Original version.
//*************************************************************************
#include <iostream>
#include "JSFSteer.h"
#include "S4PFOMakerBuf.h"
#include "S4JetMaker.h"
#include "S4JetMakerBuf.h"

ClassImp(S4JetMaker)

//=====================================================================
//* constructor -------------------------------------------------------

S4JetMaker::S4JetMaker(const char *name, const char *title)
       		  : JSFModule(name,title)
{
}

//=====================================================================
//* destructor --------------------------------------------------------

S4JetMaker::~S4JetMaker()
{
}

//=====================================================================
//* Initialize --------------------------------------------------------

Bool_t S4JetMaker::Initialize()
{
   std::cerr << " S4JetMaker::Initialize called " << std::endl;
   fEventBuf = new S4JetMakerBuf(this);
   return kTRUE;
}

//=====================================================================
//* BeginRun ----------------------------------------------------------

Bool_t S4JetMaker::BeginRun(Int_t /* run */ )
{
   return kTRUE;
}

//=====================================================================
//* Process -----------------------------------------------------------

Bool_t S4JetMaker::Process(Int_t /* ev */ )
{
   S4PFOMaker *pfomp = (S4PFOMaker *)gJSF->FindModule("S4PFOMaker");
   S4PFOMakerBuf *pfombufp = (S4PFOMakerBuf *)pfomp->EventBuf();
   S4JetMakerBuf *jetbufp = (S4JetMakerBuf *)EventBuf();
   jetbufp->SetInputDataBufPtr(pfombufp);
#if 0
   jetbufp->MakeJets();
#endif
   return kTRUE;
}
