#ifndef __S4PFOANALYSIS__
#define __S4PFOANALYSIS__
//*************************************************************************
//* -----------
//* S4PFOAnalysis
//* -----------
//* (Description)
//* 	Clasess to analyze PFO data.
//* (Update Record)
//*	2004/11/06  S.Yamamoto	Original version.
//*************************************************************************

#include "TH1.h"
#include "TH2.h"
#include "TCanvas.h"

#include "S4PFObject.h"


class S4PFOAnalysis : public JSFModule {
public:
   S4PFOAnalysis(const Char_t *name  = "S4PFOAnalysis",
		 const Char_t *title = "PFO Analysis");
   virtual ~S4PFOAnalysis();

   Bool_t Initialize();
   Bool_t Process(Int_t ev);
#if 0    
   void Draw(Option_t /* *option = "" */);
#endif

private:
   virtual void MonitorPFOs(Int_t ev);
   
private:
   TH1D     *fHPFOCharge;         //!
   TH2D     *fHPFOEclEtk;         //!
   TH2D     *fHPFOEposEtk;        //!
   TH2D     *fHPFOEclEpos;        //!
   TH2D     *fHPFOPidEclEtk;      //!
   TH1D     *fHPFOPid;            //!
   TH1D     *fHPFONo;             //!
   TH1D     *fHPFOE;              //!
   TH1D     *fHPFOEex;            //!
   TH1D     *fHPFOEnd;            //!
   TH1D     *fHPFOEe;             //!
   TH1D     *fHPFOEmu;            //!
   TH1D     *fHPFOEg;             //!   
   TH1D     *fHPFOEpi;            //!
   TH1D     *fHPFOEkl;            //!
   TH1D     *fHPFOEpr;            //!
   TH1D     *fHPFOEnu;            //!
 
#if 0
   TH1D     *fHClusterEne;        //!
   TH1D     *fHPreHitEne;         //!
   TH1D     *fHEneRatio;          //!
   TH1D     *fHTrackEne;          //!
   TH1D     *fHEneRatiotk;        //!
   TH1D     *fHDistDiff;          //!
#endif
   ClassDef(S4PFOAnalysis, 1) // PFO Analysis class
};

#endif

