#ifndef __S4PFOMAKER__
#define __S4PFOMAKER__

//*************************************************************************
//* ---------------------
//* S4PFOMaker Class
//* ---------------------
//* (Description)
//*	This set of classes makes Particle Flow Objects.
//* (Requires)
//*	JSFModules:
//* (Provides)
//*	S4PFOMaker		: steering class
//* (Update Record)
//*	2004/09/03  S.Yamamoto	Original version.
//*************************************************************************

#include "JSFModule.h"

class S4PFOMaker : public JSFModule {

public:
 S4PFOMaker(const Char_t *name  = "S4PFOMaker", 
            const Char_t *title = "Particle Flow Object Maker");
 virtual ~S4PFOMaker();

 virtual Bool_t Initialize();	     // job initialization
 virtual Bool_t BeginRun(Int_t run); // process Begin Run record
 virtual Bool_t Process(Int_t  ev);  // process event

 ClassDef(S4PFOMaker, 1)      //  PFO maker
};

#endif

