#ifndef __S4VTXHITMAKERBUF__
#define __S4VTXHITMAKERBUF__
//*************************************************************************
//* ---------------------
//* S4VTXHitMakerBuf Class
//* ---------------------
//* (Description)
//*	This set of classes makes FADC clusters.
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	S4VTXHitMakerBuf		: buffering class
//* (Update Record)
//*	2004/12/15  T.Fujikawa	Original version.
//*************************************************************************

#include "U4VTXHitMakerBuf.h"
#include "S4VTXHitMaker.h"


class S4VTXHitMakerBuf : public U4VTXHitMakerBuf {
public:
  S4VTXHitMakerBuf(const Char_t  *name    ="S4VTXHitMakerBuf",
                   const Char_t  *title   ="VTX Hit data", 
                   S4VTXHitMaker *module  = 0,
                   Int_t          size = 500);

  S4VTXHitMakerBuf(S4VTXHitMaker *module,
                   const Char_t  *name    = "S4VTXHitMakerBuf",
                   const Char_t  *title   = "VTX Hit data",
                   Int_t          size = 500);
          
  virtual ~S4VTXHitMakerBuf();

  virtual void   MakeHits() ;   // Make VTX Hits
  virtual void SetInputBufPtr(TObjArray *bufp) { fInputBufPtr = bufp; }


private:  

  TObjArray *fInputBufPtr;
  
  ClassDef(S4VTXHitMakerBuf, 1) // Cluster data buffer
};

#endif
