{
// To see the output of this macro, click begin_html <a href="gif/tornado.gif" >here</a> end_html
#include <fstream.h>
#include <iomanip.h>
#include <strstream.h>
#include <math.h>

    gSystem->Load("libPhysics.so");

    ifstream   in("exacthit.dat");
    ifstream   in2("removedhit.dat");
    TObjArray  data(10);
    TObjArray  data2(10);

    Double_t   x, y, z; 
    Double_t   maxx = -999999;
    Double_t   maxy = -999999;
    Double_t   maxz = -999999;
    Double_t   minx = 9999999;
    Double_t   miny = 999999;
    Double_t   minz = 999999;

    while (in >> x >> y >> z) {
       if (x > maxx) maxx = x;  
       if (y > maxy) maxy = y;  
       if (z > maxz) maxz = z;  
       if (x < minx) minx = x;  
       if (y < miny) miny = y;  
       if (z < minz) minz = z;  

       TVector3 *hit = new TVector3(x, y, z);
       data.Add(hit);
    }
    while (in2 >> x >> y >> z) {
       TVector3 *hit = new TVector3(x, y, z);
       data2.Add(hit);
    }

    // create and open a canvas
    sky = new TCanvas( "sky", "geom", 300, 10, 700, 700 );
    sky->SetFillColor(1);

    // creating view
#if ROOT_VERSION_CODE < ROOT_VERSION(5,15,4)
   TView   *vwp = new TView(1);
#else
   TView   *vwp = new TView3D();
   vwp->SetSystem(1);
#endif
    view->SetRange(minx-1, miny-1, minz-1, maxx+1, maxy+1, maxz+1);

    // create a PolyMarker3D
    Int_t          nhits     = data.GetEntries();
    Int_t          nhits2    = data2.GetEntries();
    TPolyMarker3D *hitpoints = new TPolyMarker3D( nhits );
    TPolyMarker3D *hitpoints2 = new TPolyMarker3D( nhits2 );

    in.close();

    // set points
    for(Int_t i=0; i<nhits; i++ ) {
       TVector3 *hit = (TVector3 *)data[i];
       hitpoints->SetPoint(i, hit->X(), hit->Y(), hit->Z()); 
    }
    for(Int_t i=0; i<nhits2; i++ ) {
       TVector3 *hit = (TVector3 *)data2[i];
       hitpoints2->SetPoint(i, hit->X(), hit->Y(), hit->Z()); 
    }

    // set marker size, color & style
    hitpoints->SetMarkerSize( 4 );
    hitpoints->SetMarkerStyle( 4 );
    hitpoints->SetMarkerColor( 5 );
    hitpoints2->SetMarkerSize( 2 );
    hitpoints2->SetMarkerStyle( 2 );
    hitpoints2->SetMarkerColor( 2 );
    
    //draw
    hitpoints->Draw();
    hitpoints2->Draw();


    TPaveText *text = new TPaveText( 0.1, 0.81, 0.9, 0.97 );
    text->SetFillColor( 42 );
    text->AddText("Geometry Test");
    text->Draw();
    sky->Update();
#endif
}

