//****************************************************
//*
//*  Dummy UserAnalysis Script to be used with gui.C 
//*  Functions in this scripts are called by GUIMainMacro.C  
//*  
//*  In this script, global functions, UserInitialize() nad UserAnalysis()
//*  Must be defined.  UserInitialize() is called at job initialization 
//*  to initialize histograms, etc.  It is also called when reset historgam
//*  menu is selected from JSF Control Panel.  UserAnalysis() is called 
//*  during the event loop after executing Process functions of JSF modules
//*  and display event daia but before display histogram.  See GetEvent()
//*  function in GUIMainMacro.C, where UserAnalysis() is called.
//*
//*  UserSetOptions() and UserTerminate() may be defined in this file.
//*  UserSetOptions() are called before declaration of JSF modules.
//*  It can be used to set parameters optional for user analsis.
//*  UserTerminate() is called during the JSF termination process.
//*
//*  When runmode=4, UserModuleDefine() must be defined in this file.
//*  It is used to define JSF modules specific to user analysis.  
//*  
//*$Id: UserAnalysis.C,v 1.1 2005/05/01 11:02:02 miyamoto Exp $
//*
//****************************************************

JetAnalysis  *anal=0;
//JSFWriteStdHep *stdhep;

//MyAnalysis *anal2=0;

//_________________________________________________________
void UserAnotherModules()
{
  anal=new JetAnalysis();  // define JetAnalysis
  //  anal2=new MyAnalysis();  // define MyAnalysis
  //  stdhep = new JSFWriteStdHep();  
}


//_________________________________________________________
void UserInitialize()
{
}

//_________________________________________________________
void UserAnalysis()
{

  //#if 1
  JSFSpring    *sp =(JSFSpring*)jsf->FindModule("EHEHSpring");
  JSFSpringBuf *spb=(JSFSpringBuf*)sp->EventBuf();
  Int_t nsps = spb->GetNpartons();
  cerr << " --- Npartons = " << nsps << " -------- " << endl;
  ANL4DVector pcm;
  TClonesArray *partons = spb->GetPartons();
  TIter next(partons);
  JSFSpringParton *parton;
  Double_t GenChgem,GenChgep,GenMassem,GenMassep,GenClrem,GenClrep,GenShwrem;
  Double_t GenShwrep,GenEem,GenEep,GenPxem,GenPxep,GenPyem,GenPyep,GenPzem,GenPzep;
  Int_t Gennum;
  Int_t GenID,GenIDem;
  while ((parton = (JSFSpringParton *)next())) {
    Gennum         = parton->GetSerial();
    GenID  = parton->GetID();
    cerr << " break -1 "<<endl;
    if(GenID ==  11){
      GenIDem  = GenID;
      GenChgem = parton->GetCharge(); 
      GenMassem= parton->GetMass();
      GenClrem = parton->GetColorID();
      GenShwrem= parton->GetShowerInfo();
      GenEem   = parton->GetE();
      GenPxem  = parton->GetPx();
      GenPyem  = parton->GetPy();
      GenPzem  = parton->GetPz();
      /*
      cerr<< Gennum  << " "
         << " PID=" << GenIDem  
         << " Q="   << GenChgem
         << " M="   << GenMassem
         << " C="   << GenClrem 
         << " S="   << GenShwrem
	 << " p=("  << GenEem  << ","
	            << GenPxem   << ","
	            << GenPyem   << ","
	            << GenPzem   << ")" << endl;*/
  }
    cerr << " break 0 "<<endl;

    if(GenID == -11){
      GenChgep = parton->GetCharge();
      GenMassep= parton->GetMass();
      GenClrep = parton->GetColorID();
      GenShwrep= parton->GetShowerInfo();
      GenEep   = parton->GetE();
      GenPxep  = parton->GetPx();
      GenPyep  = parton->GetPy();
      GenPzep  = parton->GetPz();

      /*
      cerr << Gennum  << " "
         << " PID=" << GenIDep  
         << " Q="   << GenChgep
         << " M="   << GenMassep
         << " C="   << GenClrep 
         << " S="   << GenShwrep
	 << " p=("  << GenEep  << ","
	            << GenPxep   << ","
	            << GenPyep   << ","
	            << GenPzep   << ")" << endl;
      */
    }
    
    if (parton->GetNDaughter()) continue;
    pcm += ANL4DVector(parton->GetPV());
  }
  cerr << " SpringParton : "<<endl;
  pcm.DebugPrint();
  //#endif

  //-------------------
  // Prepare Ntuple
  //-------------------
  cerr << " break 1 "<<endl;
  static TNtupleD *hEvt = 0;
  if (!hEvt) {
    stringstream tupstr;
    tupstr << "GenIDem:GenChgem:GenMassem:GenClrem:GenShwrem:GenEem:GenPxem:GenPyem:GenPzem" << ends;
    hEvt = new TNtupleD("hEvt", "", tupstr.str().data());
  }
  

  cerr << " break 2 "<<endl;
  //--                                                                      
  // Fill up Ntuple.                                              
  //--                                                                    
  Double_t data[100];
  data[ 0] = GenID;
  data[ 1] = GenChgem;
  data[ 2] = GenMassem;
  data[ 3] = GenClrem;
  data[ 4] = GenShwrem;
  data[ 5] = GenEem;
  data[ 6] = GenPxem;
  data[ 7] = GenPyem;
  data[ 8] = GenPzem;
 
  hEvt->Fill(data);
  cerr << " break 3 "<<endl;
  /*
  JSFSIMDSTBuf *sdb=(JSFSIMDSTBuf*)simdst->EventBuf();
  //  Accumulate information in the histogram
  hNCDC->Fill((Float_t)sdb->GetNCDCTracks());
  hNVTX->Fill((Float_t)sdb->GetNVTXHits());
  hNGen->Fill((Float_t)sdb->GetNGeneratorParticles());
  */


  Int_t nevt=jsf->GetEventNumber();
  if( nevt%100 == 1 ) {
    cout << "Event #=" << nevt << endl;
  }

  cerr << " break 4 "<<endl;
}

//_________________________________________________________
void DrawHist()
{
}








