      SUBROUTINE QCDMOD (ALFS,AMT,GMT,AMH,BTH,RS,Q12,Q22,FQCD)
      IMPLICIT NONE
      REAL ALFS,AMT,GMT,AMH,BTH,RS,Q12,Q22
      COMPLEX*8 FQCD
      REAL*8 E,P
      COMPLEX*16 GAMMA
      REAL A,B,C,LAM
C...
      DOUBLE PRECISION MT,MB,MW,GAMT
      COMMON/MASS/MT,MB,MW,GAMT
      DOUBLE PRECISION MUB,ASB
      COMMON/BOHR/MUB,ASB
C--
      REAL   *8 ALF, S2W, AMW, AMB, VTB, GAM1, GAM2, Q1, Q2
      REAL   *8 PI, QCDVTX
      INTEGER*4 NCALL
      DATA NCALL /0/
C...
      LAM(A,B,C) = SQRT( MAX(A**2+B**2+C**2-2.*(A*B+B*C+C*A), 0.) )
C--
C  Initialization.
C--
      IF ( NCALL.EQ.0 ) THEN
         NCALL  = 1
         PI     = ACOS(-1.D0)
         ALF    = 1/128.D0
         S2W    = 0.23D0
         AMW    = 80.D0
         AMB    =  5.D0
         VTB    =  1
         QCDVTX =  ABS( 1 - 8*ALFS/3/PI )
      ENDIF
C...
      MT = DBLE(AMT)
      GAMT = DBLE(GMT)
C...
      FQCD = (1D0,0D0)
      IF (RS.LT.SQRT(Q12)+SQRT(Q22)) RETURN
      IF ( RS.LE.2.*AMT ) THEN
         E = DBLE( RS - 2.*AMT )
      ELSEIF ( RS.GT.2.*AMT ) THEN
         E = DBLE( AMT * ( 1D0 - 4D0*AMT**2/RS**2 ) )
         E = E / ( 1D0 - E/AMT ) ! E' prescription
      ENDIF
      P = DBLE( RS/2. * LAM(1.,Q12/RS**2,Q22/RS**2) )
C     WRITE (6,*) "E, P =",E,P
      CALL READGRN (GAMMA,E,P,1)
      FQCD = CMPLX(GAMMA)
C--
C  Correction for artificial phase space suppression
C--
      Q1  = SQRT(Q12)
      Q2  = SQRT(Q22)
      IF (Q1 .LE. (AMW+AMB) .OR. Q2 .LE. (AMW+AMB)) THEN
        Q1  = MT
        Q2  = MT
      ENDIF
      CALL GTGAMT(ALF,S2W,AMW,AMB,Q1,VTB,GAM1)
      CALL GTGAMT(ALF,S2W,AMW,AMB,Q2,VTB,GAM2)
      FQCD = FQCD * GAMT/SQRT(GAM1*GAM2) * QCDVTX
C--
C  That's it.
C--
      RETURN
      END
