{
   TCanvas *c1 = new TCanvas("c1", "c1",9,31,699,550);
   gStyle->SetOptStat(0);
   c1->ToggleEventStatus();
   c1->Range(347.5,-0.8764369,1074.664,5.646552);
   c1->SetBorderSize(2);
   c1->SetLeftMargin(0.1343612);
   c1->SetBottomMargin(0.1343612);

   TH2D frame("h","",10,330.,400.,10,0.,1440.);
   frame.SetStats(0);
   frame.Draw();
   frame.GetXaxis()->SetTitle("#sqrt{s} [GeV]");
   frame.GetXaxis()->SetLabelSize(0.05);
   frame.GetXaxis()->SetTitleSize(0.06);
   frame.GetYaxis()->SetTitle("#sigma [fb]");
   frame.GetYaxis()->SetLabelSize(0.05);
   frame.GetYaxis()->SetTitleSize(0.06);
   frame.GetYaxis()->SetTitleOffset(1.1);
   frame.Draw("");

   double x[1000], y[1000], dy[1000];
   int npt = 0;
   ifstream in("xsection.new.gamcorr.nodil.dat");
   while ((in >> x[npt] >> y[npt] >> dy[npt])) npt++;
   TGraph gr(npt, x, y);
   gr.SetLineColor(8);
   gr.SetLineWidth(2);
   gr.Draw("c same");
      tex = new TLatex(332.0345,1256.4216,"F_{QCD} = #Gamma(p; E)   #sqrt{#left(#frac{#Gamma_{t}(m_{t}^{2})}{#Gamma_{t}(q_{1}^{2})}#right)#left(#frac{#Gamma_{t}(m_{t}^{2})}{#Gamma_{t}(q_{2}^{2})}#right)}");
   tex->SetTextColor(8);
   tex->SetTextSize(0.03356643);
   tex->SetLineWidth(2);
   tex->Draw();
   TArrow *arrow = new TArrow(350.2556,1150.0882,362.0365,800.9118,0.03,"|>");
   arrow->SetFillColor(8);
   arrow->SetFillStyle(1001);
   arrow->SetLineColor(8);
   arrow->SetLineWidth(2);
   arrow->SetAngle(30);
   arrow->Draw();

   npt = 0;
   in.close();
   in.open("xsection.new.gamcorr.nodil.qcdvtx.dat");
   while ((in >> x[npt] >> y[npt] >> dy[npt])) {
     y[npt] *= 1.05;
     dy[npt] *= 1.05;
     npt++;
   }
   TGraph gr2(npt, x, y);
   gr2.SetLineColor(3);
   gr2.SetLineWidth(2);
   gr2.Draw("c same");
      tex = new TLatex(355.0345,130.4216,"F_{QCD} #propto #Gamma(p; E)   #sqrt{#left(#frac{#Gamma_{t}(m_{t}^{2})}{#Gamma_{t}(q_{1}^{2})}#right)#left(#frac{#Gamma_{t}(m_{t}^{2})}{#Gamma_{t}(q_{2}^{2})}#right)}");
   tex->SetTextColor(3);
   tex->SetTextSize(0.03356643);
   tex->SetLineWidth(2);
   tex->Draw();
   TArrow *arrow = new TArrow(379.2556,278.0882,392.0365,700.9118,0.03,"|>");
   arrow->SetFillColor(3);
   arrow->SetFillStyle(1001);
   arrow->SetLineColor(3);
   arrow->SetLineWidth(2);
   arrow->SetAngle(30);
   arrow->Draw();

   npt = 0;
   in.close();
   in.open("xsection.new.nogamcorr.nodil.dat");
   while ((in >> x[npt] >> y[npt] >> dy[npt])) npt++;
   TGraph gr3(npt, x, y);
   gr3.SetLineColor(2);
   gr3.SetLineWidth(2);
   gr3.Draw("c same");
      tex = new TLatex(365.0345,1050.4216,"F_{QCD} = #Gamma(p; E)");
   tex->SetTextColor(2);
   tex->SetTextSize(0.03356643);
   tex->SetLineWidth(2);
   tex->Draw();
   TArrow *arrow = new TArrow(375.2556,1030.0882,382.0365,800.9118,0.03,"|>");
   arrow->SetFillColor(2);
   arrow->SetFillStyle(1001);
   arrow->SetLineColor(2);
   arrow->SetLineWidth(2);
   arrow->SetAngle(30);
   arrow->Draw();

   npt = 0;
   in.close();
   in.open("xsection.ref.dat");
   while ((in >> x[npt] >> y[npt] >> dy[npt])) npt++;
   TGraph gr4(npt, x, y);
   gr4.SetLineColor(4);
   gr4.SetLineWidth(2);
   gr4.SetLineStyle(2);
   gr4.Draw("c same");
      tex = new TLatex(385.0345,950.4216,"Reference");
   tex->SetTextColor(4);
   tex->SetTextSize(0.03356643);
   tex->SetLineWidth(2);
   tex->Draw();
   TArrow *arrow = new TArrow(390.2556,930.0882,396.0365,735.9118,0.03,"|>");
   arrow->SetFillColor(4);
   arrow->SetFillStyle(1001);
   arrow->SetLineColor(4);
   arrow->SetLineWidth(2);
   arrow->SetAngle(30);
   arrow->Draw();


   npt = 0;
   in.close();
   in.open("xsection.imG.dat");
   while ((in >> x[npt] >> y[npt] >> dy[npt])) npt++;
   TGraph gr5(npt, x, y);
   gr5.SetLineColor(1);
   gr5.SetLineWidth(2);
   gr5.SetLineStyle(2);
   gr5.Draw("c same");
      tex = new TLatex(387.0345,400.4216,"Im G(0;0)");
   tex->SetTextColor(1);
   tex->SetTextSize(0.03356643);
   tex->SetLineWidth(2);
   tex->Draw();
   TArrow *arrow = new TArrow(392.2556,455.0882,398.0365,645.9118,0.03,"|>");
   arrow->SetFillColor(1);
   arrow->SetFillStyle(1001);
   arrow->SetLineColor(1);
   arrow->SetLineWidth(2);
   arrow->SetAngle(30);
   arrow->Draw();

}
