#ifndef __USERANALYSIS__
#define __USERANALYSIS__

#include "VUserAnalysis.h"
#include "TStyle.h"
#include "TH1.h"
#include "TH2.h"
#include "TGraph.h"
#include "TMath.h"
#include "U4BabyTrackMaker.h"
#include "U4BabyTrackMakerBuf.h"
#include "U4BabyTrack.h"
#include "U4CDCHitMakerBuf.h"
#include "TPaveLabel.h"

#include "HardwareMapParam.dat"


class UserAnalysis : public VUserAnalysis {
public:
	UserAnalysis(BabyDisplay *display, U4CDCFADCCalibration *calib);
	virtual ~UserAnalysis();

	void InitRawFADC();
	void DrawRawFADC();
	void InitCounters();
	void DrawCounters();
	void UpdateCounterInfo();
	
	void Initialize();
	void DrawHist();

private:
        TPaveLabel   fLabel;		//!
        TH1F       **hFADC;     	//!
	TH1F	    *hHODOX;		//! Hodoscope X-axis Hits
	TH1F	    *hHODOY;		//! Hodoscope Y-axis Hits
	TH2F	    *hHODOXY;		//! Hodoscope XY scatter plot
	
	ClassDef(UserAnalysis, 1)   // A class to analyze event
};

#endif


