#ifndef __U4CDCTRACKMAKER__
#define __U4CDCTRACKMAKER__

//*************************************************************************
//* ---------------------
//* U4CDCTrackMaker Class
//* ---------------------
//* (Description)
//*
//* (Requires)
//*	JSFModules:
//* (Provides)
//*	U4CDCTrackMaker		: steering class
//* (Update Record)
//*	2002/11/15  R.Kuboshima 	Original version.
//*************************************************************************

#include "U4VTrackMaker.h"
#include "U4CDCKalDetector.h"

class U4CDCTrackMaker : public U4VTrackMaker {
public:
  U4CDCTrackMaker(const Char_t *name ="U4CDCTrackMaker",
		  const Char_t *title="CDC Track Maker");
		 
  U4CDCTrackMaker(U4CDCKalDetector *det, 
                  const Char_t *name ="U4CDCTrackMaker",
		  const Char_t *title="CDC Track Maker");
		 
  virtual ~U4CDCTrackMaker();

  virtual Bool_t Initialize()          = 0; // job initialization
  virtual Bool_t BeginRun  (Int_t run) = 0; // process Begin Run record
  virtual Bool_t Process   (Int_t  ev) = 0; // process event
  virtual U4CDCKalDetector * GetDetectorPtr() const
  { 
     return dynamic_cast<U4CDCKalDetector *>(U4VTrackMaker::GetDetectorPtr());
  }
  
private:

  ClassDef(U4CDCTrackMaker, 1) 	// Baby track maker
};

#endif
