//*************************************************************************
//* --------------------
//* U4HYBTrackMaker
//* --------------------
//* (Description)
//*	This set of classes to make hybrid tracks.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2004/09/07  K.Fujii	Origianl version.
//*************************************************************************

#include "U4HYBTrackMaker.h"
#include "U4HYBTrackMakerBuf.h"
#include "U4KalDetector.h"
#include <iostream>

ClassImp(U4HYBTrackMaker)

//=====================================================================
//* constructor -------------------------------------------------------

U4HYBTrackMaker::U4HYBTrackMaker(U4KalDetector *det,
                                 const Char_t  *name,
                                 const Char_t  *title)
               : U4VTrackMaker(det,name,title)
{
}

//=====================================================================
//* destructor --------------------------------------------------------

U4HYBTrackMaker::~U4HYBTrackMaker()
{
}

//=====================================================================
//* Initialize() ------------------------------------------------------

Bool_t U4HYBTrackMaker::Initialize()
{
   fEventBuf = new U4HYBTrackMakerBuf(this);

   return kTRUE;
}

//=====================================================================
//* BeginRun() ------------------------------------------------------

Bool_t U4HYBTrackMaker::BeginRun(Int_t run)
{
        return kTRUE;
}

//=====================================================================
//* Process -----------------------------------------------------------

Bool_t U4HYBTrackMaker::Process(Int_t /*ev*/)
{
   U4HYBTrackMakerBuf *htmbufp = dynamic_cast<U4HYBTrackMakerBuf*>(EventBuf());
   htmbufp->SetInputDataBufPtr(htmbufp->GetInputDataBufPtr());
   htmbufp->MakeTracks();
   return kTRUE;
}

//=====================================================================
//* SetMainTrackMakerPtr ----------------------------------------------

void U4HYBTrackMaker::SetMainTrackMakerPtr(U4VTrackMaker *trkmp)
{
   U4HYBTrackMakerBuf *htmbufp = dynamic_cast<U4HYBTrackMakerBuf*>(EventBuf());
   U4VTrackMakerBuf   *mtmbufp = dynamic_cast<U4VTrackMakerBuf *>(trkmp->EventBuf());
   htmbufp->SetInputDataBufPtr(mtmbufp);
}

//=====================================================================
//* AddSubTrackMakerPtr -----------------------------------------------

void U4HYBTrackMaker::AddSubTrackMakerPtr(U4VTrackMaker *trkmp)
{
   U4HYBTrackMakerBuf *htmbufp = dynamic_cast<U4HYBTrackMakerBuf*>(EventBuf());
   U4VTrackMakerBuf   *stmbufp = dynamic_cast<U4VTrackMakerBuf *>(trkmp->EventBuf());
   htmbufp->AddInputSubTracker(stmbufp);
}
