#ifndef __U4ITTRACKMAKERBUF__
#define __U4ITTRACKMAKERBUF__
//*************************************************************************
//* ---------------------
//* U4ITTrackMakerBuf Class
//* ---------------------
//* (Description)
//*
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	U4ITTrackMakerBuf		: buffering class
//* (Update Record)
//*	2004/09/06  A.Yamaguchi	    Original version.
//*************************************************************************

#include "JSFSteer.h"
#include "U4VTrackMakerBuf.h"
#include "U4ITTrackMaker.h"
#include "U4ITHitMakerBuf.h"

class U4ITTrack;

class U4ITTrackMakerBuf : public U4VTrackMakerBuf {
public:
   U4ITTrackMakerBuf(const Char_t   *name   = "U4ITTrackMakerBuf",
                     const Char_t   *title  = "IT Track data",
                     U4ITTrackMaker *module = 0,
                     Int_t           size   = 2000);
   U4ITTrackMakerBuf(U4ITTrackMaker *module,
                     const Char_t   *name  = "U4ITTrackMakerBuf",
                     const Char_t   *title = "IT Track data",
                     Int_t           size  = 2000);
     
   virtual ~U4ITTrackMakerBuf();

   virtual U4VTrack *MakeOneTrack(U4VTrack *htkp);   // Make a Track
   virtual void      DebugPrint(const Char_t *opt = "Brief");

protected:  
   virtual void MakeTracks();   // Make Tracks
  

  ClassDef(U4ITTrackMakerBuf, 1) // Cluster data buffer
};

#endif

