#ifndef __U4VHITMAKERBUF__
#define __U4VHITMAKERBUF__

//*************************************************************************
//* ---------------------
//* U4VHitMakerBuf Class
//* ---------------------
//* (Description)
//*	This set of classes makes FADC clusters.
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	U4VHitMakerBuf		: buffering class
//* (Update Record)
//*	1999/12/04  K.Fujii	Original version.
//*************************************************************************

#include "TObjArray.h"
#include "U4VHitMaker.h"

class U4VHitMakerBuf : public JSFEventBuf {
friend class U4VHitMaker;

public:

  U4VHitMakerBuf(const char *name, const char *title, 
		 U4VHitMaker *mod=0, Int_t bufsize = 2000);
  U4VHitMakerBuf(U4VHitMaker *mod,const char *name, 
  		 const char *title, Int_t bufsize = 2000);
  		    
  virtual ~U4VHitMakerBuf();
  
  virtual void 	DebugPrint(const Char_t *opt = "") {};
  
  inline virtual Bool_t IsDone() const { return fDone; }
  inline virtual Bool_t IsInitialized() const
  {
     if (fInputDataBufPtr) return kTRUE;
     else return kFALSE;
  }
  
  virtual TObjArray*   GetOutputBufPtr(); // returns array of cluster hit
  virtual Int_t	       GetEntries();	  // returns number of entries of fHits
  JSFEventBuf *        GetInputDataBufPtr() { return fInputDataBufPtr; }
  
  inline  virtual void SetDone        ( Bool_t done ) { fDone = done; }
  virtual void         SetInputDataBufPtr( JSFEventBuf* buf );
  
private:  
  virtual void	MakeHits() = 0 ; 	// Make Hits
							     
protected:

  
  Bool_t	fDone;	 		// (1,0) = (clustering done, not yet)
  TObjArray	fOutputBuf; 		// Output data buffer
  JSFEventBuf  *fInputDataBufPtr;	// Input data buffer 
  

  ClassDef(U4VHitMakerBuf, 1) // Cluster data buffer
};



#endif

