#ifndef __U4TPCHITMAKERBUF__
#define __U4TPCHITMAKERBUF__
//*************************************************************************
//* ---------------------
//* U4TPCHitMakerBuf Class
//* ---------------------
//* (Description)
//*	This set of classes makes FADC clusters.
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	U4TPCHitMakerBuf		: buffering class
//* (Update Record)
//*	2004/08/07  A.Yamaguchi	Original version.
//*************************************************************************

#include "U4VHitMakerBuf.h"
#include "U4TPCHitMaker.h"


class U4TPCHitMakerBuf : public U4VHitMakerBuf {

friend class U4TPCHitMaker;

public:

  U4TPCHitMakerBuf(const Char_t *name  = "U4TPCHitBuf",
	           const Char_t *title = "TPC Hit data", 
	           U4TPCHitMaker *module = 0, Int_t bufsize = 2000);
  U4TPCHitMakerBuf(U4TPCHitMaker *module,
	           const Char_t *name  = "U4TPCHitBuf",
	           const Char_t *title = "TPC Hit data",
	           Int_t bufsize = 2000);
		    
  virtual ~U4TPCHitMakerBuf();
  
  virtual void 	DebugPrint(const Char_t *opt = "");
  

protected:
  virtual void	MakeHits() ;	// Make TPC Hits
    

  ClassDef(U4TPCHitMakerBuf, 1) // Hit data buffer
};



#endif
