#ifndef __U4TPCTRACK__
#define __U4TPCTRACK__
//*************************************************************************
//* ---------------------
//* U4TPCTrack Class
//* ---------------------
//* (Description)
//*	Class to store "U4TPCTrackHit"s for a single layer.
//* (Requires)
//*	TObjArray
//* (Provides)
//*	U4TPCTrack		: Array containing "U4TPCTrackHit"s
//* (Update Record)
//*	2004/09/06  A.Yamaguchi     Original version.
//*************************************************************************

#include "U4TPCTrackHit.h"
#include "U4TPCTrackMaker.h"
#include "U4VTrack.h"


class U4TPCTrackHit;

class U4TPCTrack : public U4VTrack {
public:
   // ----------------------------------------------------------------------
   // C-tors and D-tor 
   // ----------------
   U4TPCTrack();
   U4TPCTrack(U4TPCTrackMaker *trkm);
   U4TPCTrack(const U4TPCTrack &tk);
   virtual ~U4TPCTrack();
 
   // ----------------------------------------------------------------------
   // Service methods
   // ---------------
   virtual void  Add(TObject *obj);
   virtual void  DebugPrint(const Char_t *opt = "Brief");
   virtual Int_t GetNhits();

   virtual void  MakeKalHits(TObjArray &kalhits);  
   virtual TKalTrackSite *GetFirstSitePtr(Bool_t dir, TObjArray *hitsp = 0);

   virtual void KalmanFilter(Bool_t dir = kIterBackward); 

private:

  
  ClassDef(U4TPCTrack, 1)                  // TPC Track
};


#endif
