#ifndef __U4VTXTRACKMAKERBUF__
#define __U4VTXTRACKMAKERBUF__
//*************************************************************************
//* ---------------------
//* U4VTXTrackMakerBuf Class
//* ---------------------
//* (Description)
//*
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	U4VTXTrackMakerBuf		: buffering class
//* (Update Record)
//*	2004/09/06  A.Yamaguchi	    Original version.
//*************************************************************************

#include "JSFSteer.h"
#include "U4VTrackMakerBuf.h"
#include "U4VTXTrackMaker.h"
#include "U4VTXHitMakerBuf.h"

class U4VTXTrack;

class U4VTXTrackMakerBuf : public U4VTrackMakerBuf {
public:
   U4VTXTrackMakerBuf(const Char_t    *name   = "U4VTXTrackMakerBuf",
                      const Char_t    *title  = "VTX Track data",
                      U4VTXTrackMaker *module = 0,
                      Int_t           size    = 2000);
   U4VTXTrackMakerBuf(U4VTXTrackMaker *module,
		      const Char_t    *name   = "U4VTXTrackMakerBuf",
		      const Char_t    *title  = "VTX Track data",
		      Int_t            size   = 2000);
     
   virtual ~U4VTXTrackMakerBuf();
   
   virtual U4VTrack *MakeOneTrack(U4VTrack *htkp);   // Make a Track
   virtual void DebugPrint(const Char_t *opt = "Brief");

protected:  
   virtual void MakeTracks();   // Make Tracks
  

  ClassDef(U4VTXTrackMakerBuf, 1) // Cluster data buffer
};

#endif

