{
   //TCanvas *c1 = new TCanvas("c1", "c1",9,31,699,550);
   TCanvas *c1 = new TCanvas("c1", "c1",384,136,657,646);
   gStyle->SetOptStat(0);
   c1->ToggleEventStatus();
   c1->Range(326.2082,-4.067669,1075.465,3.781955);
   c1->SetFillColor(30);
   c1->SetBorderMode(0);
   c1->SetBorderSize(2);
   c1->SetLogy();
   c1->SetGridx();
   c1->SetGridy();
   c1->SetTickx(1);
   c1->SetTicky(1);
   c1->SetLeftMargin(0.1251799);
   c1->SetBottomMargin(0.1343612);
#if 0
   c1->SetFrameFillColor(0);
   c1->SetFrameBorderMode(0);
#else
   Int_t ci;      // for color index setting
   TColor *color; // for color definition with alpha
   //ci = TColor::GetColor("#ffff99");
   ci = TColor::GetColor("#eeeeee");
   c1->SetFrameFillColor(ci);
   c1->SetFrameBorderMode(0);
#endif

   TH2D frame("h","",10,420.,1000.,10,0.001,1000.);
   frame.SetStats(0);
   frame.Draw();
   frame.GetXaxis()->SetTitle("#sqrt{s} [GeV]");
   frame.GetXaxis()->SetLabelSize(0.05);
   frame.GetXaxis()->SetTitleSize(0.06);
   frame.GetYaxis()->SetTitle("#sigma [fb]");
   frame.GetYaxis()->SetLabelSize(0.05);
   frame.GetYaxis()->SetTitleSize(0.06);
   frame.GetYaxis()->SetTitleOffset(1.00);
   frame.GetXaxis()->SetTickLength(0.03);
   frame.GetYaxis()->SetTickLength(0.022);
   frame.Draw("");

   TLine *line = new TLine(500.,0.001,500.,1000.);
   line->SetLineWidth(2);
   line->SetLineStyle(2);
   line->Draw();

   double x[1000], y[1000], dy[1000];
   int npt = 0;
   ifstream in("xsection.qcd2.mh125.mt173.dat");
   while ((in >> x[npt] >> y[npt] >> dy[npt])) npt++;
   TGraph gr(npt, x, y);
   gr.SetLineColor(2);
   gr.SetLineWidth(2);
   gr.Draw("same");

   Double_t x500 = 500.;
   Double_t y500 = gr.Eval(x500);
   TLine lp(x500,y500,x500+60.,y500*1.2);
   //lp.SetLineColor(2);
   lp.SetLineStyle(2);
   lp.SetLineWidth(2);
   lp.Draw();
   stringstream xval;
   xval << setprecision(2) << y500 << "fb^{-1}" << ends;
   cerr << xval.str().data() << endl;
      TLatex tex1(x500+65.,y500*1.0,xval.str().data());
   //tex1.SetTextColor(2);
   tex1.SetTextSize(0.035);
   tex1.SetLineWidth(2);
   tex1.Draw();

   TGraph grp(1,&x500,&y500);
   grp.SetMarkerStyle(8);
   grp.SetMarkerSize(1);
   grp.SetMarkerColor(2);
   grp.Draw("p same");

   npt = 0;
   in.close();
   in.open("xsection.noqcd.mh125.mt173.dat");
   while ((in >> x[npt] >> y[npt] >> dy[npt])) npt++;
   TGraph gr2(npt, x, y);
   gr2.SetLineColor(2);
   gr2.SetLineStyle(2);
   gr2.SetLineWidth(2);
   gr2.Draw("same");

   npt = 0;
   in.close();
   in.open("xsection.qcd2.hoffz.mh125.mt173.dat");
   while ((in >> x[npt] >> y[npt] >> dy[npt])) npt++;
   TGraph gr3(npt, x, y);
   gr3.SetLineColor(2);
   gr3.SetLineStyle(5);
   gr3.SetLineWidth(2);
   gr3.Draw("same");

   npt = 0;
   in.close();
   in.open("ttz.qcd2.mt173.dat");
   while ((in >> x[npt] >> y[npt] >> dy[npt])) npt++;
   TGraph gr4(npt, x, y);
   gr4.SetLineColor(4);
   gr4.SetLineWidth(2);
   gr4.Draw("same");

   x500 = 500.;
   y500 = gr4.Eval(x500);
   TLine l4p(460.,3.,x500,y500);
   //l4p.SetLineColor(4);
   l4p.SetLineStyle(2);
   l4p.SetLineWidth(2);
   l4p.Draw();
   xval.str("");
   xval.clear();
   xval << setprecision(2) << y500 << "fb^{-1}" << ends;
   cerr << xval.str().data() << endl;
      TLatex tex4(x500-70.,y500*2.5,xval.str().data());
   //tex4.SetTextColor(4);
   tex4.SetTextSize(0.035);
   tex4.SetLineWidth(2);
   tex4.Draw();

   TGraph gr4p(1,&x500,&y500);
   gr4p.SetMarkerStyle(8);
   gr4p.SetMarkerSize(1);
   gr4p.SetMarkerColor(4);
   gr4p.Draw("p same");

   npt = 0;
   in.close();
   in.open("tt.noqcd.mt173.dat");
   while ((in >> x[npt] >> y[npt] >> dy[npt])) npt++;
   TGraph gr5(npt, x, y);
   gr5.SetLineColor(1);
   gr5.SetLineWidth(2);
   gr5.Draw("same");

   x500 = 500.;
   y500 = gr5.Eval(x500);
   TLine l5p(x500-40.,y500*0.35,x500,y500);
   //l5p.SetLineColor(4);
   l5p.SetLineStyle(2);
   l5p.SetLineWidth(2);
   l5p.Draw();
   xval.str("");
   xval.clear();
   xval << setprecision(3) << y500 << "fb^{-1}" << ends;
   cerr << xval.str().data() << endl;
      TLatex tex5(x500-75.,y500*0.20,xval.str().data());
   //tex5.SetTextColor(4);
   tex5.SetTextSize(0.035);
   tex5.SetLineWidth(2);
   tex5.Draw();

   TGraph gr5p(1,&x500,&y500);
   gr5p.SetMarkerStyle(8);
   gr5p.SetMarkerSize(1);
   gr5p.SetMarkerColor(1);
   gr5p.Draw("p same");

   npt = 0;
   in.close();
   in.open("ttbb.mt173.dat");
   while ((in >> x[npt] >> y[npt] >> dy[npt])) npt++;
   TGraph gr6(npt, x, y);
   gr6.SetLineColor(1);
   gr6.SetLineWidth(2);
   gr6.Draw("same");

   TLatex *   tex = new TLatex(889.1153,306.0538,"t#bar{t}");
   tex->SetTextSize(0.04629629);
   tex->SetLineWidth(2);
   tex->Draw();
      tex = new TLatex(738.2776,27.79884,"t#bar{t}Z (w/NRQCD)");
   tex->SetTextColor(4);
   tex->SetTextSize(0.04629629);
   tex->SetLineWidth(2);
   tex->Draw();
      tex = new TLatex(515.8746,6.518064,"t#bar{t}H (w/NRQCD)");
   tex->SetTextColor(2);
   tex->SetTextSize(0.04629629);
   tex->SetLineWidth(2);
   tex->Draw();
      tex = new TLatex(533.4907,0.08884266,"t#bar{t}H (w/o NRQCD)");
   tex->SetTextColor(2);
   tex->SetTextSize(0.04629629);
   tex->SetLineWidth(2);
   tex->Draw();
      tex = new TLatex(786.7218,0.007217653,"t#bar{t}H (H off Z)");
   tex->SetTextColor(2);
   tex->SetTextSize(0.04629629);
   tex->SetLineWidth(2);
   tex->Draw();
   TArrow *arrow = new TArrow(858.2872,0.01713634,818.651,0.04548778,0.03,"|>");
   arrow->SetFillColor(2);
   arrow->SetFillStyle(1001);
   arrow->SetLineColor(2);
   arrow->SetLineWidth(2);
   arrow->SetAngle(40);
   arrow->Draw();
   arrow = new TArrow(532.3896,0.08402225,488.3494,0.03639031,0.03,"|>");
   arrow->SetFillColor(2);
   arrow->SetFillStyle(1001);
   arrow->SetLineColor(2);
   arrow->SetLineWidth(2);
   arrow->SetAngle(40);
   arrow->Draw();
   arrow = new TArrow(531.2886,5.361957,552.2077,1.486267,0.03,"|>");
   arrow->SetFillColor(2);
   arrow->SetFillStyle(1001);
   arrow->SetLineColor(2);
   arrow->SetLineWidth(2);
   arrow->SetAngle(40);
   arrow->Draw();
   arrow = new TArrow(773.5098,24.86407,815.348,5.669575,0.03,"|>");
   arrow->SetFillColor(4);
   arrow->SetFillStyle(1001);
   arrow->SetLineColor(4);
   arrow->SetLineWidth(2);
   arrow->SetAngle(40);
   arrow->Draw();
      tex = new TLatex(801.8232,0.1662865,"t#bar{t}g (g#rightarrowb#bar{b})");
   tex->SetTextSize(0.04815409);
   tex->SetLineWidth(2);
   tex->Draw();
   arrow = new TArrow(802.9091,0.4087411,773.5903,1.230942,0.03,"|>");
   arrow->SetFillColor(1);
   arrow->SetFillStyle(1001);
   arrow->SetLineWidth(2);
   arrow->SetAngle(40);
   arrow->Draw();

      tex = new TLatex(531.9668,77.32096,"Pol(e^{#pm})=0");
   tex->SetLineWidth(2);
   tex->Draw();

   c1->Modified();
   c1->cd();
   c1->SetSelected(c1);
   c1->ToggleToolBar();
}
