{
   TCanvas *c1 = new TCanvas("c1", "c1",384,136,657,646);
   gStyle->SetOptStat(0);
   c1->Range(323.75,-0.0025,386.25,0.0225);
   c1->SetFillColor(30);
   c1->SetBorderMode(0);
   c1->SetBorderSize(2);

   Int_t ci;      // for color index setting
   TColor *color; // for color definition with alpha
   //ci = TColor::GetColor("#ffff99");
   ci = TColor::GetColor("#eeeeee");
   c1->SetFrameFillColor(ci);
   c1->SetFrameBorderMode(0);
   c1->SetTickx(1);
   c1->SetTicky(1);
   
   //--
   // Open input root files.
   //--
   //////////////////////////////////////////////////////////
   TFile *qcd2 = new TFile("bases.qcd2.mh125.mt173.root");
   TFile *noqcd = new TFile("bases.noqcd.mh125.mt173.root");
   //////////////////////////////////////////////////////////
   //--
   // Set X-axis range
   //--
   Double_t xmin = 330.;
   Double_t xmax = 375.;

   //--
   // Plot w/ NRQCD
   //--
   qcd2->cd();
   TH1D *h03BS__1 = (TH1D*)gROOT->FindObject("h03BS");
   h03BS__1->SetTitle("");
   h03BS__1->SetAxisRange(xmin,xmax);

   // Get 1S peak position
   Int_t    ipeak   = h03BS__1->GetMaximumBin();
   Double_t xpeak   = h03BS__1->GetBinCenter(ipeak);
   Double_t ypeak   = h03BS__1->GetBinContent(ipeak);
   Double_t ymin    = 0.;
   Double_t ymax    = ypeak*1.3;

   h03BS__1->SetMinimum(ymin);
   h03BS__1->SetMaximum(ymax);
   h03BS__1->SetDirectory(0);
   h03BS__1->SetStats(0);
   h03BS__1->SetFillColor(50);

   ci = TColor::GetColor("#000099");
   h03BS__1->SetLineColor(ci);
   h03BS__1->GetXaxis()->SetTitle("m_{t#bar{t}} [GeV]");
   h03BS__1->GetXaxis()->SetLabelFont(42);
   h03BS__1->GetXaxis()->SetLabelSize(0.035);
   h03BS__1->GetXaxis()->SetTitleSize(0.05);
   h03BS__1->GetXaxis()->SetTitleOffset(0.85);
   h03BS__1->GetXaxis()->SetTitleFont(42);
   h03BS__1->GetXaxis()->SetTickLength(0.022);
   h03BS__1->GetYaxis()->SetLabelFont(42);
   h03BS__1->GetYaxis()->SetLabelSize(0.035);
   h03BS__1->GetYaxis()->SetTitleSize(0.05);
   h03BS__1->GetYaxis()->SetTitleFont(42);
   h03BS__1->GetYaxis()->SetTickLength(0.022);
   h03BS__1->Draw();
   
   //--
   // Plot w/o NRQCD
   //--
   noqcd->cd();
   TH1D *h03BS = (TH1D*)gROOT->FindObject("h03BS");
   h03BS->SetTitle("");
   h03BS->SetStats(0);
   h03BS->SetFillColor(42);

   ci = TColor::GetColor("#000099");
   h03BS->SetLineColor(ci);
   h03BS->Draw("same");

   //--
   // Annotations
   //--
   TLatex *   tex = new TLatex(xpeak-1.,ymax*0.38,"With QCD Correction");
   tex->SetTextSize(0.04421769);
   tex->SetLineWidth(2);
   tex->Draw();
      tex = new TLatex(xpeak+5.,ymax*0.05,"No QCD Correction");
   tex->SetTextSize(0.04421769);
   tex->SetLineWidth(2);
   tex->Draw();
      tex = new TLatex(xmin+(xmax-xmin)*0.6,ymax*0.74,"m_{t} = 173 [GeV]");
   tex->SetLineWidth(2);
   tex->Draw();
      tex = new TLatex(xmin+(xmax-xmin)*0.6,ymax*0.90,"#sqrt{s} = 500 [GeV]");
   tex->SetLineWidth(2);
   tex->Draw();
      tex = new TLatex(xmin+(xmax-xmin)*0.6,ymax*0.82,"Pol_{e^{#pm}} = 0");
   tex->SetLineWidth(2);
   tex->Draw();
      tex = new TLatex(xpeak,ymax*0.89,"1S Peak");
   tex->SetLineWidth(2);
   tex->Draw();
   TArrow *arrow = new TArrow(xpeak+2.,ymax*0.88,xpeak,ypeak*1.03,0.05,"|>");
   arrow->SetFillColor(1);
   arrow->SetFillStyle(1001);
   arrow->SetLineWidth(2);
   arrow->SetAngle(30);
   arrow->Draw();
   c1->Modified();
   c1->cd();
   c1->SetSelected(c1);
   c1->ToggleToolBar();
}
